<!DOCTYPE HTML>
<html>
<head>
    <META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
    <TITLE>pic2base - Kategorie-Sortierung</TITLE>
    <META NAME="GENERATOR" CONTENT="eclipse">
    <meta http-equiv="Content-Style-Type" content="text/css">
    <link rel=stylesheet type="text/css" href='../../css/format1.css'>
    <link rel=stylesheet type="text/css" href='../../css/main.css'>
    <link rel="shortcut icon" href="../../share/images/favicon.ico">
    <script type="text/javascript" src="../../share/functions/jquery-3.2.1.min.js"></script>
    <script type="text/javascript">
        jQuery.noConflict(); 
    </script>
</head>

<?php
IF(array_key_exists('kat_source', $_POST))
{
    $kat_source = $_POST['kat_source'];     // diese Kategorie soll samt aller Unterkategorien umgehaengt werden
}

IF(array_key_exists('kat_dest', $_POST))
{
    $kat_dest = $_POST['kat_dest'];         // unter diese Kategorie soll der Zweig wieder eingehaengt werden
}
	      
include '../../share/global_config.php';
include $sr.'/bin/share/db_connect1.php';
include $sr.'/bin/share/read_session_prefs.php';
include $sr.'/bin/share/functions/permissions.php';
include $sr.'/bin/share/functions/main_functions.php';

$res = mysqli_query($conn, "SELECT username FROM $table1 WHERE id = '$uid'");
$row = mysqli_fetch_assoc($res);
$username = $row['username'];

// ~~~~~~  verwendet ab V. 1.41.3 (nach dem 11.03.2020)  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
// ~~~~~~  Skript zur Neustrukturierung des Kategoriebaumes, wenn eine Kategorie umgehaengt werden soll  ~~~~~~~~~~~~~~~~~~~~~~~
// 
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  Was passiert?  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Tabelle 4 (Kategorien) betreffend:
// 1) Ermittlung, wo die Kategorie bisher hang und wohin sie umgehaengt werden soll
// 2) aus der Tabelle 4 (kategorien) sind die zu loeschenden Kategoriezuordnungen vom old_parent bis 
// einschliesslich der Wurzelkategorie (1) zu bestimmen und in das Array $kat_del[] zu schreiben
// 3) aus der Tabelle 4 (kategorien) sind die neu zuzuordnenden Kategorien vom kat_dest bis 
// einschliesslich der Wurzelkategorie (1) zu bestimmen und in das Array $kat_add[] zu schreiben
// 4) der umzuhaengenden Kategorie ist das neue Parent-Element zuzuordnen, sein neuer level ist zu bestimmen und allen
// Unterkategorien im umzuhaengenden Zweig sind die daraus folgenden neuen Level zuzuordnen (Aktualisierung der Tabelle 4: kategorien)
//
// Tabelle 10 (pic_kat) betreffend
// 5) aus der Tabelle 10 (pic_kat) sind fuer alle betreffenden Objekte die Kategoriezuordnungen vom old_parent
// bis einschliesslich der Wurzelkategorie (1) zu entfernen 
// 6) Die Tabelle 10 (pic_kat) ist fuer alle betreffenden Objekte mit den neuen Kategoriezuordnungen jeweils von der kat_dest
// bis zur Wurzel (1) zu aktualisieren
//
// Tabelle 2 (pictures) betreffend
// 7) Die Tabelle 2 (pictures), Feld Keywords fuer jedes Objekt ist entsprechend der aktuellen Kategoriezuweisung zu aktualisieren
// 8) Bei jedem Objekt ist das Tag IPTC:keywords entsprechend der aktuellen Kategoriezuweisung zu aktualisieren
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

// 1)

$exiftool = buildExiftoolCommand($sr);

IF($kat_source !== $kat_dest AND $kat_source !== '' AND $kat_source !== NULL AND $kat_dest !== '' AND $kat_dest !== NULL)
{
    $result1 = mysqli_query($conn, "SELECT kategorie, parent, level FROM $table4 WHERE kat_id = '$kat_source'");
	$row1 = mysqli_fetch_assoc($result1);
	$source_name = $row1['kategorie'];
	$old_parent = $row1['parent']; //unterhalb dieser Kategorie war die umzuhaengende Kat. bisher eingehaengt
	$old_level = $row1['level'];
	// fuer die Log-Datei:
	$result1_1 = mysqli_query($conn, "SELECT kategorie FROM $table4 WHERE kat_id = '$old_parent'");
	$row1_1 = mysqli_fetch_assoc($result1_1);
	$old_parent_name = $row1_1['kategorie'];

// 2)
	$kat_id1 = $old_parent;
	$kat_del = array();		//Array leeren
	$kat_del[] = $kat_id1;	//Array mit dem Startwert fuellen
	WHILE ($kat_id1 > '1')
	{
        $result3 = mysqli_query($conn, "SELECT parent FROM $table4 WHERE kat_id='$kat_id1'");
        echo mysqli_error($conn);
        $row = mysqli_fetch_array($result3);
        $kat_id1 = $row['parent'];
        $kat_del[]=$kat_id1;
	}

// 3)
	$kat_id2 = $kat_dest;
	$kat_add = array();		//Array leeren
	$kat_add[] = $kat_id2;	//Array mit dem Startwert fuellen
	WHILE ($kat_id2 > '1')
	{
            $result4 = mysqli_query($conn, "SELECT parent FROM $table4 WHERE kat_id='$kat_id2'");
            echo mysqli_error($conn);
            $row = mysqli_fetch_array($result4);
            $kat_id2 = $row['parent'];
            $kat_add[]=$kat_id2;
	}

// 4)
	// Wenn ein Kategoriezweig umgehaengt wird, wird dem Wurzelelement des Zweiges das neue Parent-Element 
	// zugewiesen und bei allen Elementen dez Zweiges muss der level aktualisiert werden.
	$result2 = mysqli_query($conn, "SELECT * FROM $table4 WHERE kat_id = \"$kat_dest\"");
	//$hint1 .="Fehler in Z. 290: ". mysqli_error($conn)."<br />";
	$row2 = mysqli_fetch_assoc($result2);
	$dest_name = $row2['kategorie'];
	$dest_level = $row2['level'];
	$new_level = $dest_level + 1;	//neuer Level der umzuhaengenden Kategorie
	
	//Ermittlung aller Unterkategorien unter der umzuhaengenden Kategorie:
	//zur Sicherheit Bereinigung der tmp_tree-Tabelle:
	$result3 = mysqli_query($conn, "DELETE FROM $table15 WHERE user_id = '$uid'"); //$hint1 .="Fehler in Z. 300: ". mysqli_error($conn)."<br />";
	//Parameter der umzuhaengenden Kat. werden in die Tabelle tmp_tree geschrieben:
	$result4 = mysqli_query($conn, "INSERT INTO $table15 (kat_id, old_level, kat_name, user_id, new_level, new_parent) VALUES (\"$kat_source\", \"$old_level\", \"$source_name\", '$uid', \"$new_level\", \"$kat_dest\")");
	
	$delta_level = $new_level - $old_level;     
    /*
    echo "Delta: ".$delta_level."<br />";
    echo "Quell-Kat: ".$kat_source."<br />";
    echo "Ziel-Kat: ".$kat_dest."<br />";
    */
	$kat_id = $kat_source;
	$k = -1;	
	
	function getTree($kat_id,$k) 
	{
	    include '../../share/global_config.php';
        include $sr.'/bin/share/db_connect1.php';
        
        $result5 = mysqli_query($conn, "SELECT * FROM $table4 WHERE parent='$kat_id'");
        $num5 = mysqli_num_rows($result5);
        //echo "Anzahl der Kind-Elemenre zur Quell-Kategorie ".$kat_id.": ".$num5."<br />";
        if($num5 > 0)
        {
            $sub_kats = "";
            $kat_arr = array();
            global $kat_arr;
            $row5 = mysqli_fetch_assoc($result5);
            
            $y = 0;
            while($y < $num5)
            {
                $kat_id = $row5['kat_id'];
                $level = $row5['level'];
                
                if(hasChildKats($kat_id))
                {
                    //echo "Kindelemente vorhanden.<br />";
                    $k++;
                    $kat_arr[$k][0] = $kat_id;
                    $kat_arr[$k][1] = $level;
                    $sub_kats = getTree($kat_id,$k);
                }
                else
                {
                    //echo "KEINE Kindelemente vorhanden.<br />";
                    $k++;
                    $kat_arr[$k][0] = $kat_id;
                    $kat_arr[$k][1] = $level;
                }
                $y++;
            }
        }
        else
        {
            $kat_arr=array();
        }
	    return $kat_arr;
  	}
  
	function hasChildKats($katID) 
	{
	    include '../../share/global_config.php';
        include $sr.'/bin/share/db_connect1.php';
        
        $result6 = mysqli_query($conn, "SELECT kat_id FROM $table4 WHERE parent='$katID'");
        $num6 = mysqli_num_rows($result6);
	    IF($num6 > 0)
	    {
	        return true;
	    }
	    ELSE
	    {
	        return false;
	    }
	}
		
	@$kategorien = getTree($kat_id,$k);  
	@$kat_arr_anz = count($kategorien);
	
	
	FOR($m='0'; $m<$kat_arr_anz; $m++)
	{
        $element = $kategorien[$m];
        $Kat = $element[0];
        $Level = $element[1];
        $korr_level = $Level + $delta_level;
        $result7 = mysqli_query($conn, "UPDATE $table4 SET level = '$korr_level' WHERE kat_id = '$Kat'");
	}
	// parent und level fuer die umzuhaengende Kategorie wird in der Tabelle 4 (kategorien) geaendert:
	// (Uebertragung der Daten aus der tmp-Tabelle in die Kategorie-Tabelle)
	$result8 = mysqli_query($conn, "SELECT * FROM $table15 WHERE user_id = '$uid'");
	$num8 = mysqli_num_rows($result8);
	FOR($i8='0'; $i8<$num8; $i8++)
	{
        $row8 = mysqli_fetch_assoc($result8);
	    $kat_id = $row8['kat_id'];
        $new_level = $row8['new_level'];
        $new_parent = $row8['new_parent'];
        IF($new_parent !== '0')
        {
            $result9 = mysqli_query($conn, "UPDATE $table4 SET level = '$new_level', parent = '$new_parent' WHERE kat_id = '$kat_id'");
        }
        ELSEIF($new_parent == '0')
        {
            $result9 = mysqli_query($conn, "UPDATE $table4 SET level = '$new_level' WHERE kat_id = '$kat_id'");
        }
	}
	
	// fuer die Log-Datei:
	$result8_1 = mysqli_query($conn, "SELECT kategorie FROM $table4 WHERE kat_id = '$new_parent'");
	$row8_1 = mysqli_fetch_assoc($result8_1);
	$new_parent_name = $row8_1['kategorie'];
    
// 5)
    
	// Bestimmung aller von der Umstrukturierung betroffenen Objekte:
	$pic_arr = array();
	$result10 = mysqli_query($conn, "SELECT * FROM $table10 WHERE kat_id = '$kat_source'");
	$num10 = mysqli_num_rows($result10);
	IF($num10 > 0)
	{
        FOR($i10=0; $i10<$num10; $i10++)
        {
            $row10 = mysqli_fetch_assoc($result10);
            $bildnr = $row10['pic_id'];
            $pic_arr[] = $bildnr;	// neu
            FOREACH($kat_del AS $kd)
            {
                $result11 = mysqli_query($conn, "DELETE FROM $table10 WHERE pic_id = '$bildnr' AND kat_id = '$kd'");
            }

// 6)
            FOREACH($kat_add AS $ka)
            {
                $result12 = mysqli_query($conn, "INSERT INTO $table10 (pic_id, kat_id) VALUES ('$bildnr', '$ka')");  //Tabelle pic_kat aktualisieren
            }
        }
// 7)
// Dieser Teil wird in exterer Fkt. doKatSort() (siehe unten) erledigt
	}
}

//log-file im Klartext schreiben:
$fh = fopen($p2b_path.'/pic2base/log/p2b.log','a');
flock($fh, LOCK_EX);
fwrite($fh,"##########\n".date('d.m.Y H:i:s').": Kategorie wurde umsortiert: ".mb_convert_encoding($source_name, "UTF-8")." (unter ".mb_convert_encoding($old_parent_name, "UTF-8").") wurde von ".mb_convert_encoding($username, "UTF-8")." nach ".mb_convert_encoding($new_parent_name, "UTF-8")." umsortiert. Zugriff von ".$_SERVER['REMOTE_ADDR'].")\n##########\n");
flock($fh, LOCK_UN);
fclose($fh);

$obj = new stdClass();
$obj->pic_anzahl = count($pic_arr);
$obj->pic_array = $pic_arr;
$output=json_encode($obj);

?>

<body lang="de-DE" onLoad='doKatSort(<?php echo json_encode($obj); ?>)'>
<div class="klein">

<?php

/*
 * Project: pic2base
 * File: kat_sort_action2.php
 *
 * Copyright (c) 2003 - 2021 Klaus Henneberg
 *
 * Project owner:
 * Dipl.-Ing. Klaus Henneberg
 * 38889 Blankenburg, BRD
 *
 * This file is licensed under the terms of the Open Software License
 * http://www.opensource.org/licenses/osl-2.1.php
 *
 * Skript wird bei der Umsortierung des Kategoriebaumes mit Anzeige des Fortschrittsbalkens verwendet (ab dem Corona-Monat 03/2020)
 */

echo "
	<div class='body_grid'>
	
		<div class='header'>
            pic2base :: Kategorie-Umsortierung
		</div>
		
		<div class='navigation'>
            <div class='menucontainer'>
            .
            </div>
		</div>
		
		<div class='content' id='content'>
		
            <span style='font-size:12px;'>
                <p style='margin:120px 0px; text-align:center'>
                    <center>
                        <p class='klein' id = 'headline'>Status der Kategorie-Umsortierung</p>
                        <p class='klein' id='zaehler'></p>
                        <div id='prog_bar' class='progress_bar' style='margin-top:30px; margin-bottom:30px;'>
                            <img src='../../share/images/green.gif' name='bar' />
                        </div>
                        <p class='klein' id='meldung'>Bitte haben Sie ein wenig Geduld...</p>
                        <p class='klein' id='counter'></p>
                    </center>
                </p>
            </span>

            <div id='blend' style='display:block; z-index:99;'>
            </div>";

            if (hasPermission($uid, 'editkattree', $sr))
            {
                $navigation = "<a class='navigation' href='kategorie0.php?kat_id=0'>Zur&uuml;ck</a>";
            }

            mysqli_close($conn);
		echo "
		</div>
		
		<div class='footer'>
            <a style='position:relative; top:8px; left:10px; font-size:10px; color:var(--color1);' HREF='http://www.pic2base.de' target='blank'>www.pic2base.de</a>
		</div>
	
	</div>";
?>
</div>
</body>
 
<script type = text/javascript>

var timeout = 1;
var gesamtanzahl;
var starttime = new Date();
var avgTime;
document.bar.width = '0';

function doKatSort( params )
{
    if( params.pic_anzahl > 0 )
    {
      	//alert(params.pic_array.length + " Objekte sind betroffen: " + params.pic_array[0] + ", " + params.pic_array[1] + ", " + params.pic_array[2]);
        gesamtanzahl = params.pic_array.length;
        document.getElementById("zaehler").innerHTML = "Anzahl der zu verarbeitenden Objekte: " + gesamtanzahl;
        processFile( params.pic_array );
    }
    else
    {
        //alert( "Es sind keine Objekt-Kategorie-Zuweisungen zu aktualisieren.\nDie Umsortierung ist abgeschlossen." );
        window.location='kat_ausw1.php';
    }	
}

function showReady( avgTime )
{
    //Erfassungsfenster leeren:
    document.getElementById("headline").innerHTML = "";
    document.getElementById("zaehler").innerHTML = "";
    document.getElementById("meldung").innerHTML = "";
    document.getElementById( "prog_bar" ).style.border = "none";
    document.bar.width = '0';
    document.bar.height = '0';
    //Fertigmeldung ausgeben bzw. Ruecksprung zur Auswahlseite:
//	alert( "Die Bearbeitung ist abgschlossen.\nDie durchschnittliche Bearbeitungszeit pro Objekt betrug " + avgTime + " Sekunden.");
    window.location='kat_ausw1.php';
}

function processFile( pic_array )
{
    //nach jedem bearbeiteten Objekt wird der Fortschrittsbalken aktualisiert
    var client = new XMLHttpRequest();
    client.open("GET", "update_pic_kategory.php?pic_id=" + pic_array[0], true);
    pic_array.splice( 0, 1 );
    client.onreadystatechange = function()
    {
        if( client.readyState == 4 )
        {
          	//alert(client.responseText);
            var result = JSON.parse( client.responseText );
            if( result.errorCode == 1 )
            {
                alert( "Es trat ein allgemeiner Fehler auf!" );
            }
            else if( result.errorCode == 2 )
            {
                alert("Sie haben entweder keine Quell- oder keine Ziel-Kategorie festgelegt!");
            }

            if( pic_array.length > 0 )
            {
                if( pic_array.length > 1)
                {
                    document.getElementById("meldung").innerHTML = "...es verbleiben noch " + pic_array.length + " Objekte...";
                }
                else
                {
                    document.getElementById("meldung").innerHTML = "...es verbleibt noch " + pic_array.length + " Objekt...";
                }
                var laenge = (gesamtanzahl - pic_array.length) / gesamtanzahl * 500;
                document.bar.src = '../../share/images/green.gif';
                document.bar.width = laenge;
                document.bar.height = '12';
                processFile( pic_array );
            }
            else
            {
                //Bearbeitung ist abgeschlossen
                //Berechnung der durchschnittlichen Bearbeitungszeit pro Objekt:
                var endtime = new Date();
                var runtime = (endtime.getTime() - starttime.getTime()) / 1000;
                avgTime = Math.round((runtime / gesamtanzahl) * 100) / 100;
                document.getElementById("meldung").innerHTML = "Alle Objekte wurden aktualisiert.";
                //Aktualisierung des Fortschrittsbalkens auf 100%:
                var laenge = (gesamtanzahl - pic_array.length) / gesamtanzahl * 300;
                document.bar.src = '../../share/images/green.gif';
                document.bar.width = laenge;
                document.bar.height = '12';
                setTimeout("showReady(avgTime,mod)", 1000);
                showReady(avgTime)
            }
        }
        else
        {
	          //alert("kat_sort_action3.php, Z. 432: " + client.readyState);
        }
    };
    client.send( null );
}

</script>
</html>