<?php
//#######################################################################################
//
// Verwendung bei der Umsortierung des Kategorie-Baumes (Aufruf von kat_sort_action3.php)
// Skript weist jedem Objekt (pic_id) die neuen Kategorien zu
//
//#######################################################################################

/*
 * Project: pic2base
 * File: update_pic_kategory.php
 *
 * Copyright (c) 2005 - 2021 Klaus Henneberg
 *
 * Project owner:
 * Dipl.-Ing. Klaus Henneberg
 * 38889 Blankenburg, BRD
 *
 * This file is licensed under the terms of the Open Software License
 * http://www.opensource.org/licenses/osl-2.1.php
 */

$error_code = 0;

include '../../share/global_config.php';
include $sr.'/bin/share/db_connect1.php';
include $sr.'/bin/share/read_session_prefs.php';
include $sr.'/bin/share/functions/main_functions.php';

if(array_key_exists('pic_id',$_GET))
{
    $pic_id = $_GET['pic_id'];
}
else
{
    $pic_id = 0;
}

$result0 = mysqli_query($conn, "SELECT * FROM $table1 WHERE id = '$uid' AND aktiv = '1'");
$row0 = mysqli_fetch_assoc($result0);
$username = $row0['username'];
if ( isset($pic_id))
{
	$exiftool = buildExiftoolCommand($sr);
	$FN = strtolower($pic_path."/".restoreOriFilename($pic_id, $sr));
	
	$result13 = mysqli_query($conn, "SELECT $table10.pic_id, $table10.kat_id, $table4.kat_id, $table4.kategorie
	FROM $table4, $table10
	WHERE $table10.pic_id = '$pic_id'
	AND $table4.kat_id = $table10.kat_id
	AND $table4.kat_id <> '1'");
	$num13 = mysqli_num_rows($result13);
	$kategorie = '';

	for($i13=0; $i13<$num13; $i13++)
	{
		$row13 = mysqli_fetch_assoc($result13);
	    $sel_kategorie = $row13['kategorie'];
		$kategorie .= ", ".$sel_kategorie;
	}
	
	// pictures.keywords aktualisieren
	// Keywords wird auf max. 250 Zeichen (Feldlänge in Tabelle pictures) gekürzt:
	$db_kw = substr($kategorie,'0','249');
	$res3 = mysqli_query($conn, "UPDATE $table2 SET Keywords = \"$db_kw\", has_kat = '1' WHERE pic_id = '$pic_id'");
	// Metadaten (keywords) des Objektes 'pic_id' aktualisieren
	
	if(strlen($kategorie) > 64)
	{
	    // Da immer nur 64 Zeichen lange Blöcke in einem Zug nach IPTC:Keywords geschrieben werden können, wird $kategorie hier gesplittet:
	    writeIptcKeywords($pic_id, $kategorie, $sr);
	}
	else
	{
	    //$exiftool = buildExiftoolCommand($sr);
	    $command = $exiftool." -IPTC:Keywords=\"$kategorie\" -overwrite_original ".$FN;
	    shell_exec($command);
	}
	
	if (mysqli_errno($conn) == '0')
	{
		$error_code = 0;
		// im Erfolgsfall Log-Datei schreiben:
		$fh = fopen($p2b_path.'/pic2base/log/p2b.log','a');
		flock($fh, LOCK_EX);
		fwrite($fh,date('d.m.Y H:i:s').": Kategoriezuordnung von Objekt ".$pic_id." wurde von ".$username." modifiziert. (Zugriff von ".$_SERVER['REMOTE_ADDR']."\n(Kategorie-Umsortierung)\n");
		flock($fh, LOCK_UN);
		fclose($fh);
	}
	else
	{
		$error_code = 1;
	}
}
else
{
	$error_code = 2; 
}

$obj1 = new stdClass();
//$obj1->kwstring = $keyword_string;
$obj1->errorCode = $error_code;
$obj1->Userid = $uid;
$output = json_encode($obj1);
echo $output;
?>