<!DOCTYPE HTML>
<html>

<head>
  <title>Kollektion umsortieren</title>
  <meta name="GENERATOR" content="eclipse">
  <meta name="AUTHOR" content="k. henneberg">
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <link rel=stylesheet type='text/css' href='../../css/format1.css'>
  <link rel=stylesheet type='text/css' href='../../css/main.css'>
  <link rel="shortcut icon" href="../../share/images/favicon.ico">
  
  <script src='../../share/functions/jquery-3.2.1.min.js'></script>
  <script src='../../share/functions/jquery.elevatezoom.js'></script>
  <script type="text/javascript" src="../../share/functions/jquery-ui.min.js"></script>
  <script type="text/javascript">
    jQuery.noConflict();
    jQuery(function() 
    {
        jQuery("#sortable" ).sortable({ 
            cursor: "move", 
            opacity: 0.7, 
            revert: true,
            stop: function (evt, ui)
                {
//                  alert("neue Pos.: " + jQuery("#sortable li").index(ui.item) + ", alte Pos.: " + ui.item.attr('id'));
                }
            });
        jQuery("#sortable" ).disableSelection();
    });
  </script>
  
  <style>	
    #sortable { list-style-type: none; margin: 0; padding: 0; }
    #sortable li { margin: 1px; padding: 1px; float: left; width: 200px; height: 200px; }
  </style>
</head>

<body>
<?php

/*
 * Project: pic2base
 * File: arrange_collection.php
 * Ansicht der ausgewaehlten Kollektion (Uebersicht aller Objekte)
 * Copyright (c) 2013 - 2021 Klaus Henneberg
 *
 * Project owner:
 * Klaus Henneberg
 * Finkenweg 18
 * 38889 Blankenburg, BRD
 *
 * All files of this project are licensed under the terms of the Open Software License
 * http://www.opensource.org/licenses/osl-2.1.php
 */

include '../../share/global_config.php';
include $sr.'/bin/share/db_connect1.php';
include $sr.'/bin/share/read_session_prefs.php';
include $sr.'/bin/share/functions/main_functions.php';
//include $sr.'/bin/css/initial_layout_settings.php';

if(array_key_exists('coll_id', $_GET))
{
    $coll_id = $_GET['coll_id'];
    $_SESSION['coll_id'] = $coll_id;
}

$max_size = 200;	//max. Ausdehnung des Vorschaubildbereichs in px

$result1 = mysqli_query($conn, "SELECT $table25.pic_id, $table25.coll_id, $table24.coll_id, $table24.coll_name, $table2.pic_id, $table2.FileNameHQ 
FROM $table2, $table25, $table24 
WHERE $table25.coll_id = '$coll_id'
AND $table24.coll_id = $table25.coll_id
AND $table25.pic_id = $table2.pic_id
ORDER BY position");
$num1 = mysqli_num_rows($result1);
$result2 = mysqli_query($conn, "SELECT coll_name FROM $table24 WHERE coll_id = '$coll_id'");
$row2 = mysqli_fetch_assoc($result2);
$coll_name = $row2['coll_name'];
if(strlen($coll_name) > 65)
{
    $coll_name = substr($coll_name, 0, 65)."...";
}
echo "
<div class='klein'>
    <div class='body_grid'>

        <div class='header'>
            pic2base :: Ansicht der Kollektion \"".$coll_name."\"
        </div>

        <div class='navigation'>
            <div class='menucontainer'>";
            createNavi3_2($uid);
            echo "
            </div>
        </div>

        <div class='content' id='content'>
            <div class='collection_grid'>
                <div class='collection_content'>
                    <fieldset class='normal' style='height:96%;overflow-y:scroll;'>
                    <legend class='normal'>Ansicht der ausgew&auml;hlten Kollektion</legend>
                        <div id='scrollbox3'>
                            <ul id='sortable'>";
                                if ($num1 > 0)
                                {    
                                    for($i1=0; $i1<$num1; $i1++)
                                    {
                                        $row1 = mysqli_fetch_assoc($result1);
                                        $pic_id = $row1['pic_id'];
                                        $FileNameHQ = $row1['FileNameHQ'];
                                        $pic_size = getimagesize($sr."/images/vorschau/hq-preview/$FileNameHQ");
                                        $pic_breite = $pic_size[0]; 
                                        $pic_hoehe = $pic_size[1];
                                        //echo $FileNameHQ.": B x H: ".$pic_breite." / ".$pic_hoehe;
                                        if($pic_breite > $pic_hoehe)
                                        {
                                            $oberer_abstand = (($max_size - (176 / $pic_breite) * $pic_hoehe) / 2); //$oberer_abstand = 0;	
                                            $rechter_abstand = (($max_size - 176) / 2);                             //$rechter_abstand=0;						
                                            echo "
                                            <li id=".$pic_id.">
                                                <div id='img'>
                                                    <img class='img' src='../../../images/vorschau/hq-preview/$FileNameHQ' style='width:176px; border-style:solid; border-bottom-width:".$oberer_abstand."px; border-top-width:".$oberer_abstand."px; border-right-width:".$rechter_abstand."px; border-left-width:".$rechter_abstand."px; border-radius:10px; border-color:#222222; margin:2px;' data-zoom-image='../../../images/vorschau/hq-preview/$FileNameHQ' />
                                                </div>
                                            </li>";
                                        }
                                        else
                                        {
                                            $oberer_abstand = (($max_size - 176) / 2);
                                            $rechter_abstand = (($max_size - (176 / $pic_hoehe) * $pic_breite) / 2);
                                            echo "
                                            <li id=".$pic_id.">
                                                <div id='img'>
                                                    <img  class='img' src='../../../images/vorschau/hq-preview/$FileNameHQ' style='height:176px; border-style:solid; border-bottom-width:".$oberer_abstand."px; border-top-width:".$oberer_abstand."px; border-right-width:".$rechter_abstand."px; border-left-width:".$rechter_abstand."px; border-radius:10px; border-color:#222222; margin:2px;' data-zoom-image='../../../images/vorschau/hq-preview/$FileNameHQ' />
                                                </div>
                                            </li>";
                                        }
                                    }
                                    $visibility="visible";
                                }
                                else
                                {
                                    echo "<p style='margin-left:200px; margin-top:100px; font-size:20px; color:red;'>Es ist ein Fehler aufgetreten...!</p>";
                                    $visibility="hidden";
                                }
                            echo "
                            </ul>
                        </div>
                    </fieldset>
                </div>

                <div class='collection_action'>
                    <fieldset class='normal' style='overflow-y:scroll'>
                    <legend class='normal'>Aktion</legend>
                        <div id='scrollbox6' style='height:23px;'><center>
                            <input type='button' name='save' value='Sortierung speichern' class='button5' style='visibility:$visibility' title='Speichert die neue Sortier-Reihenfolge dieser Kollektion' onclick='saveChanges($num1, $coll_id, \"save\")'>
                            <input type='button' name='save_as' value='Sortierung speichern unter' class='button5' style='visibility:$visibility' title='Die umsortierte Kollektion wird unter einem neuen Namen gespeichert' onclick='saveChanges($num1, $coll_id, \"save_as\")'>
                            <input type='button' name='slideshow' value='Dia-Show (Vorschau)' class='button5' style='visibility:$visibility' title='Dia-Show starten' onclick='location.href=\"show_presentation.php?coll_id=$coll_id&qual=lq\"'>
                            <input type='button' name='cancel' value='Abbrechen und zur&uuml;ck' class='button5' title='Die Sortierung wird verworfen' onclick='location.href=\"edit_collection.php\"'>
                            </center>
                        </div>
                    </fieldset>
                </div>

            </div>
        </div>

        <div class='footer'>
            <a style='position:relative; top:8px; left:10px; font-size:10px; color:var(--color1);' HREF='http://www.pic2base.de' target='blank'>www.pic2base.de</a>
        </div>

    </div>
</div>";
?>
    
<script type="text/javascript">
function saveChanges(num1, coll_id, save_mode)
{
    //alert("save changes..." + num1 + " Objekte, Koll-ID: " + coll_id);
    var jsonPositions = Array();
    //alert( document.getElementById( "sortable" ) );
    var uListElement = document.getElementById( "sortable" );
    for( var i = 0; i < uListElement.children.length; ++i )
    {
        var objLi = uListElement.children[ i ];
        jsonPositions.push( {"idx":( i + 1 ),"picId":objLi.id} );
    }

    if(save_mode == "save")
    {
            //alert( JSON.stringify( jsonPositions ) );
            jQuery.ajax({
                type: "POST",
                url: "save_new_order.php",
                data: "coll_id=" + coll_id + "&picIdx=" + JSON.stringify( jsonPositions ) + "&save_mode=" + save_mode,
                success: function(response)
                  {
                    //alert( "Neue Sortierung wurde gespeichert." + response );
                    alert( "Neue Sortierung wurde gespeichert." );
                  }
              });
    }
    else if(save_mode == "save_as")
    {
        //location.href="save_new_order.php?coll_id=" + coll_id + "&picIdx=" + JSON.stringify( jsonPositions ) + "&save_mode=" + save_mode;
        //alert("Coll-ID: " + coll_id + ", Save-Mode: " + save_mode + ", Objekt-Positionen: " + JSON.stringify( jsonPositions ));

        function postToUrl(coll_id, bild_positionen) 
        {
            var form = document.createElement("form");
               form.setAttribute("method", "POST");
               form.setAttribute("action", "save_new_order.php");

            var hiddenField1 = document.createElement("input");
               hiddenField1.setAttribute("type", "hidden");
               hiddenField1.setAttribute("name", "coll_id");
               hiddenField1.setAttribute("value", coll_id);
               form.appendChild(hiddenField1);

            var hiddenField2 = document.createElement("input");
               hiddenField2.setAttribute("type", "hidden");
               hiddenField2.setAttribute("name", "save_mode");
               hiddenField2.setAttribute("value", "save_as");
               form.appendChild(hiddenField2);

            var hiddenField3 = document.createElement("input");
               hiddenField3.setAttribute("type", "hidden");
               hiddenField3.setAttribute("name", "picIdx");
               hiddenField3.setAttribute("value", bild_positionen);
               form.appendChild(hiddenField3);

            document.body.appendChild(form);
            form.submit();
            return false;
        }

        postToUrl(coll_id, JSON.stringify( jsonPositions ));
    }
}
</script>
</body>
</html>