<!DOCTYPE HTML>
<html>
<head>
	<meta http-equiv="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<title>pic2base - Geo-Referenzierung</title>
	<link rel=stylesheet type="text/css" href='../../css/format1.css'>
	<link rel=stylesheet type="text/css" href='../../css/main.css'>
	<link rel=stylesheet type="text/css" href='../../css/tooltips.css'>
	<link rel="shortcut icon" href="../../share/images/favicon.ico">
	<script type="text/javascript" src="../../ajax/inc/prototype.js"></script>
	<script type="text/javascript" src="../../share/functions/jquery-3.2.1.min.js"></script>
	<script type="text/javascript">
	  	jQuery.noConflict();
	</script>
</head>

<body style='text-align:center;'lang="de-DE" scroll = "auto">
<div class="klein">

<?php

/*
 * Project: pic2base
 * File: edit_geo_daten_action.php
 *
 * Copyright (c) 2005 - 2023 Klaus Henneberg
 *
 * Project owner:
 * Dipl.-Ing. Klaus Henneberg
 * 38889 Blankenburg, BRD
 *
 * This file is licensed under the terms of the Open Software License
 * http://www.opensource.org/licenses/osl-2.1.php
 */

include '../../share/global_config.php';
include $sr.'/bin/share/db_connect1.php';
include $sr.'/bin/share/read_session_prefs.php';
include $sr.'/bin/share/functions/geo_functions.php';
include $sr.'/bin/share/functions/main_functions.php';
include $sr.'/bin/share/functions/permissions.php';
//var_dump($uid);

if (!hasPermission($uid, 'georefallpics', $sr) AND !hasPermission($uid, 'georefmypics', $sr))
{
    echo "
    	<div class='body_grid'>
    	
    		<div class='header'>
    			pic2base :: Datensatz-Bearbeitung (Geo-Referenzierung) <span class='klein'>(User: $username)</span>
    		</div>
    		
    		<div class='navigation'>
    			<div class='menucontainer'>";
    			createNavi3_1($uid);
    			echo "</div>
    		</div>

			<div class='content'>
            	<div class='content_grid_filmstripe'>
     
					<div class='filmstripe_content_left' id='spalte1' style='overflow: hidden;'>
						<fieldset class='normal' style=' height: 95%;overflow: hidden;'>
						<legend class='normal'>Es ist ein Fehler aufgetreten</legend>
							<div id='scrollbox0' style='overflow-y:scroll; padding-top:50px;'>
								<p class='klein_red' style='margin-top:100px;'>Sie haben keine Berechtigung, Objekte zu geo-referenzieren.<br /><br />
								Wenden Sie sich bitte an den Administrator.</p>
							</div>
						</fieldset>
					</div>
    
					<div class='filmstripe_content_right' id='spalte2' style='overflow: hidden;'>
                		<fieldset class='normal' style=' height:95%; overflow-y:scroll;'>
						<legend class='normal'>Fehlende Berechtigung!</legend>
							<div id='scrollbox1' style='overflow-y:scroll; padding-top:50px; text-align:center;'>
							</div>
						</fieldset>	    
					</div>

				</div>

			</div>
    					    
    		<div class='footer'>
    			<a style='position:relative; top:8px; left:10px; font-size:10px; color:var(--color1);' HREF='http://www.pic2base.de' target='blank'>www.pic2base.de</a>
    		</div>
    					    
    	</div>";
    return;
}
else 
{ 
    //echo "<font color='white'>User darf referenzieren.</font>";

    if ( array_key_exists('timezone',$_POST) )
    {
    	$timezone = $_POST['timezone'];
    }
    if ( array_key_exists('data_logger',$_POST) )
    {
    	$data_logger = $_POST['data_logger'];
    }
    // Track nur ansehen oder referenzieren? ->
    if ( array_key_exists('ge',$_POST) )
    {
    	$ge = $_POST['ge'];
    }
    
    $result0 = mysqli_query($conn, "UPDATE $table1 SET timezone = '$timezone', logger_type = '$data_logger' WHERE id = '$uid'");
    $result1 = mysqli_query($conn, "SELECT * FROM $table1 WHERE id = '$uid' AND aktiv = '1'");
    $row1 = mysqli_fetch_array($result1);
    $username = $row1['username'];
    //var_dump($_FILES);
    $geo_file = $_FILES['geo_file']['name'];
    $geo_file_name = $track_path."/".$geo_file;

    if ($geo_file == '')
    {
    	echo mysqli_error($conn);
    	echo "<H3 style='color:var(--color_r); margin-top:150px;'>Fehler!<br /><br />Sie m&uuml;ssen eine g&uuml;ltige Track-Datei ausw&auml;hlen!</H3>";
    	echo "<meta http-equiv='Refresh', content='2; url=edit_geo_daten.php'>";
    	return;
    }
    
    if ($geo_file_name != "" && $geo_file_name !='.' && $geo_file_name != '..')
    {
    	move_uploaded_file($_FILES['geo_file']['tmp_name'],$geo_file_name)
    	or die("Upload fehlgeschlagen!");
    	$error = getFileError($_FILES['geo_file']['error']);
    }

    if ($fh = fopen($geo_file_name, 'r'))
    {
        $txt_file = implode('',file($track_path."/".$geo_file));
        $line_number = 0;	//Initialisierung des Zeilen-Zaehlers
        
        //Ermittlung des Datei-Formates:
        $info = pathinfo($geo_file_name);
        //echo "Funktionsparameter: Server-Root: ".$sr.", Daten-Logger: ".$data_logger.", Datei-Extension: ".strtolower($info['extension']).", UID: ".$uid.", Zeitzone: ".$timezone."<br />";
        //die ausgewaehlte Trackdatei wird ueberprueft, bei Erfolg in eine kml-Datei konvertiert und der Inhalt
        //(Geo-Koordinaten und Zeitstempel in die geo_tmp (table13) geschrieben
        convertFile($sr,$data_logger,$info,$geo_file_name,$uid,$timezone);
        //Bestimmung der verwertbaren Datensaetze:
        $result2 = mysqli_query($conn, "SELECT * FROM $table13 WHERE user_id = '$uid'");
        $line_number = mysqli_num_rows($result2);
    }
    else
    {
        die("Trackdatei konnte nicht gelesen werden...");
    }

    switch($ge)
    {
    	case 'Los!':
    	// Wenn Geo-Referenzierung ausgewaehlt wurde:
    	switch($line_number)
    	{
    		case '0':
    		$hinweis1 = "Zeilen-Zahl: ".$line_number."<br />
    		Bei der ausgew&auml;hlten Datei handelt es sich nicht um eine g&uuml;ltige Trackpunkte-Datei!";
    		return;
    		
    		default:
    		$hinweis1 = "Die Track-Datei enth&auml;lt ".$line_number." verwertbare Trackpunkte.<br /><br />";
    		//aus der temp. Tabelle wird fuer jeden Tag die Zeitspanne (der frueheste und spaeteste Zeitpunkt) ermittelt:
    		$result4 = mysqli_query($conn, "SELECT DISTINCT date FROM $table13 WHERE user_id = '$uid'");
    		$num4 = mysqli_num_rows($result4);
    		$hinweis2 = '';
    		for ($i4=0; $i4<$num4; $i4++)
    		{
    			$row4 = mysqli_fetch_assoc($result4);
    		    $datum = $row4['date'];
    			//echo "vorh. Datum: ".$datum."<br />";
    			//Zu jedem vorh. Datum wird die Zeitspanne vorh. Trackdaten bestimmt:
    			$result5 = mysqli_query($conn, "SELECT MIN(time), MAX(time) FROM $table13 WHERE date = '$datum' AND user_id = '$uid'");
    			$row5 = mysqli_fetch_assoc($result5);
    			$min_time = $row5['MIN(time)'];
    			$max_time = $row5['MAX(time)'];
    			
    			//echo "Zeitspanne: ".$min_time." - ".$max_time."<br />";
    			//in Abhaengigkeit der Berechtigung des Benutzers werden alle Objekte, keine Objekte oder nur die Objekte des Users ermittelt, 
    			// welche an dem besagten Tag in der ermittelten Zeitspanne aufgenommen wurden und denen noch keine Koordinaten zugewiesen wurden:
    			$start_time = $datum." ".$min_time;
    			$end_time = $datum." ".$max_time;
    			//echo "Startzeit: ".$start_time.", Endzeit: ".$end_time."<br />";
    			
    			if (hasPermission($uid, 'georefmypics', $sr))
    			{
        			$result6 = mysqli_query($conn, "SELECT pic_id, FileName, Owner, CreateDate, City, GPSLatitude, GPSLongitude, aktiv
        			FROM $table2
        			WHERE CreateDate >= '$start_time' 
        			AND CreateDate <= '$end_time' 
        			AND (City ='Ortsbezeichnung' OR City = '' OR GPSLongitude = '0' OR GPSLatitude = '0')
        			AND Owner = '$uid'
        			AND aktiv = '1'");
    			}
    			elseif (hasPermission($uid, 'georefallpics', $sr))
    			{
    			    $result6 = mysqli_query($conn, "SELECT pic_id, FileName, Owner, CreateDate, City, GPSLatitude, GPSLongitude, aktiv
        			FROM $table2
        			WHERE CreateDate >= '$start_time'
        			AND CreateDate <= '$end_time'
        			AND (City ='Ortsbezeichnung' OR City = '' OR GPSLongitude = '0' OR GPSLatitude = '0')
                    AND aktiv = '1'");
    			}
    			
    			$num6 = mysqli_num_rows($result6);
    			//echo "<p style='color:white';>Treffer fuer User ".$uid.": ".$num6."</p><br />";
    			$pic_count = 0;
    			if($num6 > '0')
    			{
    				for ($i6=0; $i6<$num6; $i6++)
    				{
    					$row6 = mysqli_fetch_assoc($result6);
    				    $pic_id = $row6['pic_id'];
    				    $FileName = $row6['FileName'];
    				    $pic_time = $row6['CreateDate'];
    					//echo $FileName.", Aufnahme-Zeit: ".$pic_time."<br />";
    					//Fr jedes Objekt wird ermittelt, welche Trackpunkte mit einer zeitlichen Abweichung von +/- $delta Sekunden existieren:
    					$delta = 60;
    					$anz = getTrackPoints($delta,$pic_time,$datum);
    					switch($anz)
    					{
    						case '0':
    						//Wenn keine passenden Trackdaten gefunden wurden, passiert nix ausser einer Info.
    //						$hinweis2 .= "Zum Objekt ".$pic_id." gibt es <font color='red'>KEINE</font> passenden Trackpunkte bei Delta = ".$delta."<br />";
    						break;
    			
    						default:
    						//Wenn es Trackpunkte gibt, welche innerhalb des Zeitfensters liegen, wird dieses von 0 beginnend so lange vergroessert, bis mind. ein Trackpunkt gefunden wurde:
    						$delta = -1;
    						$anz = 0;
    						while($anz == 0)
    						{
    							$delta++;
    							$anz = getTrackPoints($delta,$pic_time,$datum);
    						}
    						//Die Daten der betreffenden Punkte werden ermittelt, in die Tabelle 'pictures' zur passenden pic_id geschrieben
    						findTrackData($delta,$pic_time,$datum,$pic_id);
    //						$hinweis2 .= "Objekt ".$pic_id.": <font color='green'>".$anz."</font> Trackpunkt(e) (Delta = ".$delta.")<br />";
    						$pic_count++;
    						break;
    					}
    				}
    			}
    			else
    			{
    				$hinweis2 = "Es wurden keine Objekte am ".date('d.m.Y',strtotime($datum)).", von ".$min_time." Uhr bis ".$max_time." Uhr (UTC) aufgenommen,<br />oder alle in diesem Zeitraum aufgenommenen Objekte wurden bereits mit Geo-Daten referenziert.<br /><br />
    				M&ouml;glicherweise haben aber noch nicht alle Objekte eine korrekte Ortsbezeichnung.";
    			}
    		}
    		break;
    	}
	
    	// Bestimmung aller Objekte, die von der Kamera aus mit Geo-Koordinaten geliefert wurden, aber noch ohne Ortszuweisung sind:
    	if (hasPermission($uid, 'georefmypics', $sr))
    	{
        	$result3 = mysqli_query($conn, "SELECT Owner, City, GPSLongitude, GPSLatitude, aktiv 
        	FROM $table2 
        	WHERE Owner = '$uid' 
        	AND (City = 'Ortsbezeichnung' OR City = '')
        	AND GPSLongitude <> 'NULL'
        	AND GPSLatitude <> 'NULL'
        	AND aktiv = '1'");
        	echo mysqli_error($conn);
    	}
    	elseif (hasPermission($uid, 'georefallpics', $sr))
    	{
    	    $result3 = mysqli_query($conn, "SELECT Owner, City, GPSLongitude, GPSLatitude, aktiv
        	FROM $table2
        	WHERE (City = 'Ortsbezeichnung' OR City = '')
        	AND GPSLongitude <> 'NULL'
        	AND GPSLatitude <> 'NULL'
        	AND aktiv = '1'");
    	    echo mysqli_error($conn);
    	}
    	$num3 = mysqli_num_rows($result3);
    
    	echo "
    	<div class='body_grid'>
    		
    		<div class='header'>
    			pic2base :: Datensatz-Bearbeitung (Geo-Referenzierung) <span class='klein'>(User: $username)</span>
    		</div>
    		
    		<div class='navigation'>
    			<div class='menucontainer'>";
    				createNavi3_1($uid);
    			echo "</div>
    		</div>

			<div class='content'>
            	<div class='content_grid_filmstripe'>
    		
					<div class='filmstripe_content_left' id='spalte1' style='overflow: hidden;'>
						<fieldset class='normal' style=' height: 95%;overflow: hidden;'>
						<legend class='normal'>Details zur Track-Datei</legend>
							<div id='scrollbox0' style='overflow-y:scroll; padding-top:50px;'>
								<p class='klein'>Name der Track-Datei: ".($_FILES['geo_file']['name'])."<br />
								Trackdatei-Gr&ouml;sse: ".($_FILES['geo_file']['size'])." Byte<br />".
								$error.$hinweis1."</p>
							</div>
						</fieldset>
						
					</div>
    		
					<div class='filmstripe_content_right' id='spalte2' style='overflow: hidden;'>
                		<fieldset class='normal' style=' height:95%; overflow-y:scroll;'>
						<legend class='normal'>Hinweise zur Referenzierung</legend>
							<div id='scrollbox1' style='overflow-y:scroll; padding-top:50px; text-align:center;'>";
								//Wenn alle Objekte referenziert wurden, werden die benutzereignen Datens&auml;tze aus der temp. Tabelle 'geo_tmp' gel&ouml;scht und nochmals alle Objekte dargestellt, damit den Koordinaten eine Ortsbezeichnung hinzugefgt werden kann:
								$result8 = mysqli_query($conn, "DELETE FROM $table13 WHERE user_id = '$uid'");
								echo "<p class='klein' style='text-align:left;'>Die Geo-Referenzierung wurde im ersten Schritt abgeschlossen.<br /><br />
								Ergebnis der Koordinaten-Zuweisung:<br /><br />".$hinweis2."<br /></p>";
								if ($pic_count == 1)
								{
									echo "<p class='klein' style='text-align:left;'>
									<u>Ein Objekt</u> mu&szlig; aus dieser Track-Datei mit einem Ortsnamen versehen werden.<br />
									</p>";
								}
								elseif ($pic_count > 1)
								{
									echo "<p class='klein' style='text-align:left;'>
									<u>".$pic_count." Objekte</u> m&uuml;ssen aus dieser Track-Datei mit einem Ortsnamen versehen werden.<br />
									</p>";
								}
								//Das Delta repr&auml;sentiert den zeitlichen Versatz der Aufnahmezeit zum zeitlich n&auml;chsten aufgezeichneten Trackpunkt.<br />D.h., je geringer das Delta ist, desto genauer ist die Referenzierung
								echo "<p class='klein' style='text-align:left;'>Daneben existieren <u>".$num3." Objekte</u>, die zwar Geo-Koordinaten, aber noch keine Ortsbezeichnung haben.
								Klicken Sie auf \"Weiter\", um zur Ortzuweisung zu gelangen.<br /></p>
								<p align='center'>
								<input type='button' class='button' value='Weiter' OnClick='location.href=\"edit_location_name.php\"'>
								</p><br />
							</div>
						</fieldset>
					</div>

				</div>

			</div>
    
    		<div class='footer'>
    			<a style='position:relative; top:8px; left:10px; font-size:10px; color:var(--color1);' HREF='http://www.pic2base.de' target='blank'>www.pic2base.de</a>
    		</div>
    	
    	</div>
    	</FORM>";
    	break;
    	
    //#############################################################################################################################	
    
    	case 'Track ansehen':
    	// Wenn der Track nur in GE angezeigt werden soll:
    	// Da die gpx-Datei schrittweise vom Anfang an abgearbeitet wird, erfolgt der Eintrag in die Tabelle in zeitlicher Reihenfolge. 
		// Somit genuegt eine Sortierung beim auslesen nach loc_id.
    	$result2 = mysqli_query($conn, "SELECT * FROM $table13 
    	WHERE user_id = '$uid' AND longitude <> '' AND latitude <> '' 
    	ORDER BY loc_id");
    	$num2 = mysqli_num_rows($result2);
    	$row2 = mysqli_fetch_assoc($result2);
    	$date = $row2['date'];
    	if ($date !== '0000-00-00')
    	{
    		$datum = date('d.m.Y', strtotime($date));
    	}
    	else
    	{
    		$datum = date('d.m.Y');
    	}
    	$content = '<?xml version="1.0" encoding="UTF-8"?>
    			<kml xmlns="http://earth.google.com/kml/2.1">
    			<Document>
    			<name>'.$datum.'</name>
    			<description>Ansicht des Streckenverlaufs</description>
    			<Style id="yellowLineGreenPoly">
    			<LineStyle>
    			<color>7f00ffff</color>
    			<width>4</width>
    			</LineStyle>
    			<PolyStyle>
    			<color>77f00ff00</color>
    			</PolyStyle>
    			</Style>
    			<Placemark>
    			<name>Track-Ansicht</name>
    			<description>Transparente gr&#252;ne Mauer mit gelben Umriss</description>
    			<styleUrl>#yellowLineGreenPoly</styleUrl>
    			<LineString>
    			<extrude>1</extrude>
    			<tessellate>1</tessellate>
    			<altitudeMode>relative</altitudeMode>
    			<coordinates>';
    	
    	for ($i2='0'; $i2<$num2 -1; $i2++)
    	{
    		$row2 = mysqli_fetch_assoc($result2);
    	    $lat = $row2['latitude'];
    	    $long = $row2['longitude'];
    		$content .= $long.','.$lat."\n"; 
    	}
    	$content .= '	</coordinates>
    			</LineString>
    			</Placemark>
    			</Document>
    			</kml>';

    	//kml-Datei erzeugen und mit Inhalt ($content) fuellen
		//echo "edit_geo_daten_action.php, Z. 408: KML-Pfad: ".$kml_dir."<br>";
		//echo "edit_geo_daten_action.php, Z. 408: SR-Pfad: ".$sr."<br>";
		$kml_dir = $sr."/userdata/".$uid."/kml_files";
    	$file = time().".kml";
    	$file_name = $kml_dir."/".$file; 
		//echo "edit_geo_daten_action.php, Z. 408: KML-Datei: ".$file_name."<br>";
    	$fh = fopen($file_name,'w');
    	if(flock($fh, LOCK_EX))
		{
			fwrite($fh,$content);
			flock($fh, LOCK_UN);
			fflush($fh);
		}
		else
		{
			"Konnte Datei-Sperre nicht erhalten.";
		}
    	//Wenn kml-Track-Datei erzeugt wurde, werden die benutzereignen Datensaeze aus der temp. Tabelle 'geo_tmp' geloescht:
    	$result9 = mysqli_query($conn, "DELETE FROM $table13 WHERE user_id = '$uid'");
    	
    	echo "
    	<div class='body_grid'>
    		
    		<div class='header'>
    			pic2base :: Track-Darstellung in GoogleEarth <span class='klein'>(User: $username)</span>
    		</div>
    				
    		<div class='navigation'>
    			<div class='menucontainer'>";
    				createNavi3_1($uid);
    			echo "</div>
    		</div>

			<div class='content'>
            	<div class='content_grid_filmstripe'>
    		
					<div class='filmstripe_content_left' id='spalte1' style='overflow: hidden;'>
						<fieldset class='normal' style=' height: 95%;overflow: hidden;'>
						<legend class='normal'>Zur Ansicht in GoogleEarth</legend>
							<div id='scrollbox0' style='overflow-y:scroll; padding-top:50px;'>
								<div id='tooltip1'><p class='klein'>Streckenverlauf in <a class='std' href='../../../userdata/$uid/kml_files/$file'>GoogleEarth
									<span>
									<strong>Zur Anzeige des Streckenverlaufs in GoogleEarth ist es erforderlich, da&#223; GoogleEarth auf Ihrem Rechner installiert ist.</strong><br />
									<br />
									Ein kostenfreier Download steht unter http://earth.google.de zur Verf&uuml;gung.
									</span>
									</a>darstellen</p>
								</div>
							</div>
						</fieldset>
					</div>
    		
					<div class='filmstripe_content_right' id='spalte2' style='overflow: hidden;'>
                		<fieldset class='normal' style=' height:95%; overflow-y:scroll;'>
						<legend class='normal'>Hinweise</legend>
							<div id='scrollbox1' style='overflow-y:scroll; padding-top:50px; text-align:center;'>
								<p class='klein'>Klicken Sie in der linken Spalte auf 'GoogleEarth' um den ausgew&auml;hlten Track in GoogleEarth darzustellen.</p>
							</div>
						</fieldset>
					</div>

				</div>

			</div>
    	
    		<div class='footer'>
    			<a style='position:relative; top:8px; left:10px; font-size:10px; color:var(--color1);' HREF='http://www.pic2base.de' target='blank'>www.pic2base.de</a>
    		</div>
    	
    	</div>";
    	break;
    }
}
fclose($fh);
mysqli_close($conn);
?>
</div>
</body>
</html>