<?php

/*
 * Project: pic2base
 * File: edit_location_name_action.php
 * wird aufgerufen von: edit_location_name.php
 * benoetigt: alle includierten Dateien
 *
 * Copyright (c) 2005 - 2021 Klaus Henneberg
 *
 * Project owner:
 * Dipl.-Ing. Klaus Henneberg
 * 38889 Blankenburg, BRD
 *
 * This file is licensed under the terms of the Open Software License
 * http://www.opensource.org/licenses/osl-2.1.php
 */

$ort = filter_input(INPUT_POST, 'ort');

$pic_id = filter_input(INPUT_POST, 'pic_id', FILTER_VALIDATE_INT, array('options'=>array('default'=>-1)));
if($pic_id <= 0)
{
    exit;
}

if(array_key_exists('auto_ref', $_POST))
{
        $auto_ref = $_POST['auto_ref'];
        if($auto_ref == 1)
        {
                setcookie("auto_ref","1");
                //setcookie("next_location",$ort);
        }
        elseif($auto_ref == 0) 
        {
                setcookie ("auto_ref", "", time() - 3600);
                //setcookie ("next_location", "", time() - 3600);
        }
}

include '../../share/global_config.php';
include $sr.'/bin/share/db_connect1.php';
include $sr.'/bin/share/read_session_prefs.php';
include $sr.'/bin/share/functions/geo_functions.php';
include $sr.'/bin/share/functions/main_functions.php';

$exiftool = buildExiftoolCommand($sr);

$result1 = mysqli_query($conn, "UPDATE $table2 SET City='$ort' WHERE pic_id = '$pic_id'");
//Eintragung des Ortsnamens an den Anfang des Beschreibungstextes des zugehoerigen Bildes:
$result3 = mysqli_query($conn, "SELECT * FROM $table2 WHERE pic_id = '$pic_id'");
$row3 = mysqli_fetch_assoc($result3);
//$pic_id = $row3['pic_id'];
$description_alt = $row3['Caption_Abstract'];
$description_neu = "Kamerastandort: ".$ort."; ".$description_alt;
//Bestimmung der Geo-Koordinaten
$long = $row3['GPSLongitude'];
$lat = $row3['GPSLatitude'];
$alt = $row3['GPSAltitude'];
$city = $row3['City'];
//Bestimmung des Dateinamens der Original-Datei:
$FN = $pic_path."/".restoreOriFilename($pic_id, $sr);
//Bestimmung des zugehoerigen jpg-Dateinamens:
$fn = $row3['FileName'];
$fn = $pic_path."/".$fn;
// Ermittlung der Long-/Lat-Referenzen:
if($lat < 0)
{
        $lat_ref = "S";
}
else
{
        $lat_ref = "N";
}

if($long < 0)
{
        $long_ref = "W";
}
else
{
        $long_ref = "E";
}
//Update des Objekt-Datensatzes:
$result4 = mysqli_query($conn, "UPDATE $table2 SET Caption_Abstract = '$description_neu', GPSLatitudeRef = '$lat_ref', GPSLongitudeRef = '$long_ref' WHERE pic_id = '$pic_id'");
//Speicherung der Geo-Koordinaten, Geo-Referenz, Ortsbezeichnung und Beschreibung in der Original-Objekt-Datei:
$command1 = $exiftool." -IPTC:city='$city' ".$FN." -overwrite_original -execute -EXIF:GPSLongitude=".$long." ".$FN." -overwrite_original -execute -EXIF:GPSLongitudeRef=".$long_ref." ".$FN." -overwrite_original -execute -EXIF:GPSLatitude=".$lat." ".$FN." -overwrite_original -execute -EXIF:GPSLatitudeRef=".$lat_ref." ".$FN." -overwrite_original -execute -EXIF:GPSAltitude=".$alt." ".$FN." -overwrite_original -execute -IPTC:Caption-Abstract='$description_neu' ".$FN." -overwrite_original 2>&1";
shell_exec($command1);
//exec($command1,$output);
//Eintragung der Geo-Koordinaten, Geo-Referenz, Ortsbezeichnung und Beschreibung in der zugehoerigen jpg-Datei:
$command2 = $exiftool." -IPTC:city='$city' ".$fn." -overwrite_original -execute -EXIF:GPSLongitude=".$long." ".$fn." -overwrite_original -execute -EXIF:GPSLongitudeRef=".$long_ref." ".$fn." -overwrite_original -execute -EXIF:GPSLatitude=".$lat." ".$fn." -overwrite_original -execute -EXIF:GPSLatitudeRef=".$lat_ref." ".$fn." -overwrite_original -execute -EXIF:GPSAltitude=".$alt." ".$fn." -overwrite_original -execute -IPTC:Caption-Abstract='$description_neu' ".$fn." -overwrite_original 2>&1";
@shell_exec($command2);

//#############################################################################
//verbleibende Objekte ohne Referenzierung:
$result2 = mysqli_query($conn, "SELECT CreateDate, pic_id, Owner, FileNameV, City, GPSLongitude, GPSLatitude, aktiv 
        FROM $table2 
        WHERE (Owner = '$uid' 
        AND (City = 'Ortsbezeichnung' OR City = '')
        AND GPSLongitude <> 'NULL'
        AND GPSLatitude <> 'NULL'
        AND aktiv = '1') 
        ORDER BY CreateDate ASC");
//                      echo mysqli_error($conn);
$number_of_pictures = mysqli_num_rows($result2);
$row2 = mysqli_fetch_assoc($result2);

$response = new stdClass();
$response->totalNumberOfPicturesRemaining = $number_of_pictures;
if($number_of_pictures == 0)
{
    //wenn alle Objekte referenziert wurden, wird bei den uebersprungenen (skipped) Bildern des angemeldeten Users City wieder auf 'Ortsbezeichnung' gesetzt:
    $result5 = mysqli_query($conn, "UPDATE $table2 SET City = 'Ortsbezeichnung' WHERE City = 'skipped' AND Owner = '$uid'");
    $next_pic_id = '';
    $next_location = '';
}
else
{
    $next_pic_id = $row2['pic_id'];
    $next_location = getNextLocation($sr,$next_pic_id); //in: /share/functions/geo_functions.php
    $response->nextPicId = $next_pic_id;
    $response->nextLocation = $next_location; 
}
echo json_encode($response);