<?php

/*
 * Project: pic2base
 * File: run_ocr.php
 *
 * Copyright (c) 2005 - 2021 Klaus Henneberg
 *
 * Project owner:
 * Dipl.-Ing. Klaus Henneberg
 * 38889 Blankenburg, BRD
 *
 * This file is licensed under the terms of the Open Software License
 * http://www.opensource.org/licenses/osl-2.1.php
 */

if(array_key_exists('pic_id',$_GET))
{
    $pic_id = $_GET['pic_id'];
}
else
{
    $pic_id = 0;
}

if(array_key_exists('sharpen',$_GET))
{
    $sharpen = $_GET['sharpen'];
}
else
{
    $sharpen = 5;
}

if(array_key_exists('quality',$_GET))
{
    $quality = $_GET['quality'];
}
else
{
    $quality = 100;
}

if(array_key_exists('resize',$_GET))
{
    $resize = $_GET['resize'];
}
else
{
    $resize = 100;
}

//#############################################################################################
//                                                                                            |
// Verwendung bei der Texterkennung                                                           |
// Skript versucht aus jedem Objekt (pic_id) den enthaltenen Text                             |
// zu extrahieren und nach $table2.OCR_Result zu schreiben                                    |
// wird aufgerufen bei der Texterkennung ( von ocr_action.php)                                |
//                                                                                            |
//#############################################################################################

$error_code = 0;
include '../../share/read_session_prefs.php';
include '../../share/global_config.php';
include $sr.'/bin/share/db_connect1.php';
include $sr.'/bin/share/functions/main_functions.php';

$exiftool = buildExiftoolCommand($sr);

$result0 = mysqli_query($conn, "SELECT username FROM $table1 WHERE id = '$uid' AND aktiv = '1'");
$row0 = mysqli_fetch_assoc($result0);
$username = $row0['username'];

if ( isset($pic_id) )
{    
    /*
    1) aus dem Original-JPG wird eine Graustufen-Kopie erzeugt
    2) Diese wird optimiert (sharpen, ...) und vorübergehend im kml-Ordner des angemeldeten Users abgelegt
    3) Daraus wird mittels tesseract evtl. enthaltener Text extrahiert,
    4) dieser von 'Zeichen-Müll' bereinigt,
    5) in die DB nach $table2.OCR_Result geschrieben und
    6) abschließend die temp. Graustufendatei gelöscht
    */
    $conv = buildConvertCommand($sr);
    $ta = buildTesseractCommand($sr);
    
    // Wo ist das jpg-Bild-Objekt?
    $res1 = mysqli_query($conn, "SELECT FileName FROM $table2 WHERE pic_id = '$pic_id'");
    $row1 = mysqli_fetch_assoc($res1);
    $filename = $row1['FileName'];
    $dest_filename = $pic_id."_gray.jpg";
    // mit den Konvertierungs-Parametern muß ggf. experimentiert werden...
    $params = $pic_path."/".$filename." -type Grayscale -sharpen ".$sharpen." -quality ".$quality." -resize ".$resize."% -density 600 -set units PixelsPerInch ".$kml_dir."/".$dest_filename;
    $output = shell_exec($conv." ".$params);
 	// OCR anhand der Graustufen-Kopie:    
    $command = "export LD_LIBRARY_PATH=$(dirname $(locate libstdc++.so | head -1)) && ".$ta." ".$kml_dir."/".$dest_filename." stdout -l deu  2>&1";
    //$command = $ta." ".$kml_dir."/".$dest_filename." stdout -l deu  2>&1";
    $command = $ocr_result = shell_exec($command);
    
    // Bereinigung des OCR-Resultats von 'Zeichen-Müll'; hier Apostrophen, spitze Klammern:
    $ocr_result = str_replace("'", " ", $ocr_result);
    $ocr_result = str_replace("<", " ", $ocr_result);
    $ocr_result = str_replace(">", " ", $ocr_result);
    // Ergebnis in der DB speichern:
    $res2 = mysqli_query($conn, "UPDATE $table2 SET OCR_Result = '$ocr_result' WHERE pic_id = '$pic_id'");
    
    // bearbeitete Dateien aus dem kml-Ordner des Users löschen:
    // Kann, muß aber hier nicht erledigt werden, da der kml-Ordner bei jeder Neuanmeldung geleert wird
    /*
    if(!unlink($kml_dir."/".$dest_filename))
    {
        $error_code = 3;
    }
    */
    if(!mysqli_error($conn))
    {
        // Log-Datei schreiben:
        $fh = fopen($p2b_path.'/pic2base/log/p2b.log','a');
        flock($fh, LOCK_EX);
        fwrite($fh,date('d.m.Y H:i:s').": Objekt ".$pic_id." wurde erfolgreich einer Texterkennung unterzogen. Parameter: ".$params."(Zugriff von ".$_SERVER['REMOTE_ADDR'].")\n");
        flock($fh, LOCK_UN);
        fclose($fh);
        $error_code = 0;
    }
    else
    {
        // Fehlermeldung schreiben:
        $fh = fopen($p2b_path.'/pic2base/log/p2b.log','a');
        flock($fh, LOCK_EX);
        fwrite($fh,date('d.m.Y H:i:s').": Fehler bei der Texterkennung bei Objekt ".$pic_id.": ".mysqli_error($conn)."\n");
        flock($fh, LOCK_UN);
        fclose($fh);
        $error_code = 1;
    }

    if (mysqli_errno($conn) == '0')
    {
        $error_code = 0;
    }
    else
    {
        $error_code = 1;
    }
    
}
else
{
    $error_code = 2; 
}
//$msqlerr = mysqli_error($conn);
mysqli_close($conn);

$obj1 = new stdClass();
$obj1->sharpen=$sharpen;
$obj1->quality=$quality;
$obj1->resize=$resize;
//$obj1->mysql_error=$msqlerr;
$obj1->ocr_result=$ocr_result;
$obj1->errorCode = $error_code;
$obj1->Userid = $uid;
$output = json_encode($obj1);
echo $output;
?>