<?php
header('Content-Type: text/html; charset=utf-8');

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
// Verwendung bei der Bearbeitung / Download skalieren / Text einstempeln
// 
// wird aufgerufen bei Bearbeitung | Download skalieren / stempeln ( von edit_scale_stamp_action.php)
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

/*
 * Project: pic2base
 * File: stamp_picture_.php
 *
 * Copyright (c) 2005 - 2020 Klaus Henneberg
 *
 * Project owner:
 * Dipl.-Ing. Klaus Henneberg
 * 38889 Blankenburg, BRD
 *
 * This file is licensed under the terms of the Open Software License
 * http://www.opensource.org/licenses/osl-2.1.php
 */

if(array_key_exists('width',$_GET))
{
    $width = $_GET['width'];
}

if(array_key_exists('stamp_text',$_GET))
{
    $stamp_text = $_GET['stamp_text'];
}
else
{
    $stamp_text = "";
}

if(array_key_exists('fontsize',$_GET))
{
    $fontsize = $_GET['fontsize'];
}

if(array_key_exists('fontcolor',$_GET))
{
    $fontcolor = $_GET['fontcolor'];
}
else
{
    $fontcolor = 0;
}

if(array_key_exists('margin_left',$_GET))
{
    $margin_left = $_GET['margin_left'];
}
else
{
    $margin_left = 0;
}

if(array_key_exists('vertical_align',$_GET))
{
    $vertical_align = $_GET['vertical_align'];
}
else
{
    $vertical_align = 0;
}

if(array_key_exists('bg_opacity',$_GET))
{
    $bg_opacity = $_GET['bg_opacity'];
}
else
{
    $bg_opacity = 10; 
}

if(array_key_exists('bgcolor',$_GET))
{
    $bgcolor = $_GET['bgcolor'];
}
else
{
    $bgcolor = 0;
}

if(array_key_exists('pic_id',$_GET))
{
    $pic_id = $_GET['pic_id'];
}
//var_dump($_GET);
$error_code = 0;

include '../../share/read_session_prefs.php';
include '../../share/global_config.php';
include $sr.'/bin/share/db_connect1.php';
include $sr.'/bin/share/functions/main_functions.php';
$convert = buildConvertCommand($sr);
// zu bearbeitende Datei:
$file_in = $down_dir."/".$pic_id;
$info = pathinfo($pic_id); //print_r($info);
$file_out = $down_dir."/".$info['filename']."_small.".$info['extension'];
$tmp_bg_pic = $kml_dir."/tmp_bg_pic.jpg";   // temporäres Hintergrundbild
// Aus der Vorgabe, wie vert. ausgerichtet werden soll und der zu erreichenden Breite des Bildes wird die vert. Einfügeposition ermittelt:
$image_size = getimagesize($file_in);
$image_width = $image_size[0];
$image_height = $image_size[1];
switch($vertical_align)
{
    case 0:
    $va = $fontsize + 10;
    break;
    
    case 50:
    $va = $image_height * $width / (2 * $image_width);
    break;
    
    case 100:
    $va = ($image_height * $width / $image_width) - $fontsize;
    break;
}

// Farbwerte-Konvertierung von aabbcc nach #aabbcc
$fc = "#".$fontcolor;
$bc = "#".$bgcolor;

// Farbwerte-Konvertierung Hex -> RGB:
// Schriftfarbe:
$fcol = preg_replace("/[^0-9A-Fa-f]/", '', $fontcolor);
$fcolorVal = hexdec($fcol);
$f_rgbArray['red'] = 0xFF & ($fcolorVal >> 0x10);
$f_rgbArray['green'] = 0xFF & ($fcolorVal >> 0x8);
$f_rgbArray['blue'] = 0xFF & $fcolorVal;
implode(',', $f_rgbArray);
//print_r($f_rgbArray);

// Hintergrundfarbe:
$bgcol = preg_replace("/[^0-9A-Fa-f]/", '', $bgcolor);
$bgcolorVal = hexdec($bgcol);
$bg_rgbArray['red'] = 0xFF & ($bgcolorVal >> 0x10);
$bg_rgbArray['green'] = 0xFF & ($bgcolorVal >> 0x8);
$bg_rgbArray['blue'] = 0xFF & $bgcolorVal;
implode(',', $bg_rgbArray);
//print_r($bg_rgbArray);

// 1) Bild skalieren:
$cmd1 = $convert." ".$file_in." -resize ".$width."x ".$file_out;
shell_exec($cmd1);

// 2) Hintergrund-Rechteck zeichnen:
// Koordinaten des Hintergrund-Rechtecks:
// rxa -> rectangle X Anfang
// rya -> rectangle Y Anfang
// rxe -> rectangle X Ende
// rye -> rectangle Y Ende
$rxa = 0;
$rya = $va;
$rxe = $width;
$rye = $va - $fontsize - 4; // -2: oberer Rand zum Text

$im = @imagecreatefromjpeg($file_out);
$bg_pic_color = imagecolorallocatealpha($im, $bg_rgbArray['red'],$bg_rgbArray['green'],$bg_rgbArray['blue'],((10 - $bg_opacity) * 12.7));
imagefilledrectangle($im, $rxa, $rya, $rxe, $rye, $bg_pic_color);

// 3) Text eintragen (Variante 1):
$font_pic_color = imagecolorallocate($im, $f_rgbArray['red'],$f_rgbArray['green'],$f_rgbArray['blue']);
// Pfad zur Schriftart-Datei
$font_file = $sr."/bin/share/fonts/DejaVuSans.ttf";
// Koordinaten des Text-Beginns
// txa -> Text X Anfang
// tya -> Text Y Anfang
$txa = $margin_left;
$tya = $rya - 2;    // -2: unterer Rand zum Text
imagefttext($im, $fontsize, '0', $txa, $tya, $font_pic_color, $font_file, $stamp_text);

header('Content-Type: image/jpeg');
imagejpeg($im,$file_out);
imagedestroy($im);

mysqli_close($conn);

$obj1 = new stdClass();
$obj1->errorCode = $error_code;
$obj1->Userid = $uid;
$obj1->width = $width;
$obj1->stamp_text = $stamp_text;
$obj1->fontsize = $fontsize;
$obj1->fontcolor = $fontcolor;
$obj1->margin_left = $margin_left;
$obj1->vertical_align = $vertical_align;
$obj1->bg_opacity = $bg_opacity;
$obj1->bgcolor = $bgcolor;
$obj1->bb = $image_width;
$obj1->bh = $image_height;
$output = json_encode($obj1);
echo $output;
?>