<?php
header('Content-Type: text/html; charset=utf-8');
/*
 * Project: pic2base
 * File: update_desc_daten_.php
 *
 * Copyright (c) 2005 - 2020 Klaus Henneberg
 *
 * Project owner:
 * Dipl.-Ing. Klaus Henneberg
 * 38889 Blankenburg, BRD
 *
 * This file is licensed under the terms of the Open Software License
 * http://www.opensource.org/licenses/osl-2.1.php
 */

if(array_key_exists('pic_id',$_GET))
{
    $pic_id = $_GET['pic_id'];
}
else
{
    $pic_id = 0;
}

if(array_key_exists('copyright_id',$_GET))
{
    $copyright_id = $_GET['copyright_id'];
}
else
{
    $copyright_id = NULL;
}

if(array_key_exists('del_old_cr',$_GET))
{
    $del_old_cr = $_GET['del_old_cr'];
}
else
{
    $del_old_cr = 0;
}

if(array_key_exists('kat_id',$_GET))
{
    $kat_id = $_GET['kat_id'];
}
else
{
    $kat_id = 0;
}

//#####################################################################################
//
// Verwendung bei der Bearbeitung - Copyright-Vermerk zuweisen (Auswahl nach Kategorien)
// Skript weist jedem Objekt (pic_id) den neuen Copyright-Vermerk zu
// wird aufgerufen bei Bearbeitung | Copyright-Vermerk zuweisen ( von edit_copyright_vermerk_action2.php)
//
//#####################################################################################

$error_code = 0;

include '../../share/global_config.php';
include $sr.'/bin/share/db_connect1.php';
include $sr.'/bin/share/read_session_prefs.php';
include $sr.'/bin/share/functions/main_functions.php';
$exiftool = buildExiftoolCommand($sr);

$result0 = mysqli_query($conn, "SELECT username FROM $table1 WHERE id = '$uid' AND aktiv = '1'");
$row0 = mysqli_fetch_assoc($result0);
$username = $row0['username'];
$bild_id = $pic_id;
//Was wurde als neuer Copyright-Vermerk zwischengespeichert?
$res2 = mysqli_query($conn, "SELECT copyright FROM $table14 WHERE cr_id = '$copyright_id' AND user_id = '$uid'");
$row2 = mysqli_fetch_assoc($res2);
$add_copyright = $row2['copyright'];

// alter Copyright-Vermerk wird vollst. durch neuen ersetzt:
if(isset($pic_id) AND $copyright_id !== "" AND $del_old_cr == 1)
{
    //Ersetzen des bisherigen Copyright-Vermerks durch den neuen:
    //echo "ersetze...";
    $Copyright = mb_convert_encoding($add_copyright, "UTF-8");
    $add_copyright = htmlentities($add_copyright, ENT_QUOTES);
    $res1 = mysqli_query($conn, "UPDATE $table2 SET Copyright = '$add_copyright' WHERE pic_id = '$bild_id'");
    //Log-Daten schreiben:
    $fh = fopen($p2b_path.'/pic2base/log/p2b.log','a');
    
    if(!mysqli_error($conn))
    {
        //Log-Datei im Erfolgsfall schreiben:
        flock($fh, LOCK_EX);
        fwrite($fh,date('d.m.Y H:i:s').": Copyright von Objekt ".$bild_id." wurde von ".mb_convert_encoding($username, "UTF-8")." modifiziert. (Zugriff von ".$_SERVER['REMOTE_ADDR'].", alter Vermerk wurde entfernt, neu: ".$Copyright."\n");
        //fwrite($fh,date('d.m.Y H:i:s').": Copyright von Objekt ".$bild_id." wurde von ".mb_convert_encoding($username, "UTF-8")." modifiziert. (Zugriff von ".$_SERVER['REMOTE_ADDR'].", alter Vermerk wurde entfernt, neu: ".mb_convert_encoding($Copyright, "UTF-8")."\n");
        flock($fh, LOCK_UN);
    }
    else
    {
        $error_code = 3;
        //Log-Datei im Fehlerfall schreiben:
        flock($fh, LOCK_EX);
        fwrite($fh,date('d.m.Y H:i:s').": Fehler beim Speichern des Copyright-Vermerks von Objekt ".$bild_id.": ". mysqli_error($conn).", neuer Copyright-Vermerk soll lauten: ".mb_convert_encoding($Copyright, "UTF-8")."\n");
        flock($fh, LOCK_UN);
    }
    fclose($fh);
    
}
// oder um neuen ergänzt:
elseif ( isset($pic_id) AND $copyright_id !== "" AND ($del_old_cr == 0))
{
    //Ermittlung des bisherigen Copyright-Vermerks:
    //echo "ergänze...";
    $res1 = mysqli_query($conn, "SELECT Copyright FROM $table2 WHERE pic_id = '$bild_id'");
    $row1 = mysqli_fetch_array($res1);
    $old_copyright = html_entity_decode($row1['Copyright']);         
    //echo mysqli_error($conn);

    // Montage des neuen Beschreibungstextes
    if ($add_copyright == '')
    {
        $Copyright = $old_copyright;
    }
    else
    {
        $Copyright =$old_copyright." ".$add_copyright;
    }
    $cr = mb_convert_encoding($Copyright, "UTF-8");
    $Copyright = htmlentities($Copyright, ENT_QUOTES);
    $res3 = mysqli_query($conn, "UPDATE $table2 SET Copyright = '$Copyright' WHERE pic_id = '$bild_id'");
    $error = mysqli_error($conn);
    $fh = fopen($p2b_path.'/pic2base/log/p2b.log','a');
    $old_copyright = mb_convert_encoding($old_copyright, "UTF-8");
    
    if(!mysqli_error($conn))
    {
        //Log-Datei im Erfolgsfall schreiben:
        fwrite($fh,date('d.m.Y H:i:s').": Copyright von Objekt ".$bild_id." wurde von ".$username." modifiziert. (Zugriff von ".$_SERVER['REMOTE_ADDR'].", alt: ".$old_copyright.", neu: ".$cr."\n");
    }
    else 
    {
        $error_code = 3;
        //Log-Datei im Fehlerfall schreiben:
        fwrite($fh,date('d.m.Y H:i:s').": Fehler beim Speichern des Copyright-Vermerks von Objekt ".$bild_id.": ". mysqli_error($conn).", alt: ".$old_copyright.", neuer Copyright-Vermerk soll lauten: ".$cr."\n");
    }
    fclose($fh);
}
    
// Nur wenn die DB-Aktualisierung erfolgreich war, werden die Metadaten aktualisiert. Ansonsten wird eine Fehlermeldung ausgegeben.
if ($error_code == 0)
{
    $FN = $pic_path."/".restoreOriFilename($bild_id, $sr);
    shell_exec($exiftool." -IPTC:CopyrightNotice=\"$cr\" ".$FN." -overwrite_original");

    if (mysqli_errno($conn) == '0')
    {
        $error_code = 0;
    }
    else
    {
        $error_code = 1;
    }
}
else
{
    $error_code = 2; 
}
mysqli_close($conn);

$obj1 = new stdClass();
$obj1->del_old_cr = $del_old_cr;
$obj1->errorCode = $error_code;
//$obj1->error = $error;
$obj1->Userid = $uid;
$obj1->kat_id = $kat_id;
$output = json_encode($obj1);
echo $output;
?>