<?php

/*
 * Project: pic2base
 * File: update_kat_daten_.php
 *
 * Copyright (c) 2005 - 2022 Klaus Henneberg
 *
 * Project owner:
 * Dipl.-Ing. Klaus Henneberg
 * 38889 Blankenburg, BRD
 *
 * This file is licensed under the terms of the Open Software License
 * http://www.opensource.org/licenses/osl-2.1.php
 */

//#####################################################################################
//
// Verwendung bei der Bearbeitung / Kategoriezuordnung (Auswahl nach Kategorien)
// Skript weist jedem Objekt (pic_id) die neuen Kategorien zu
// wird aufgerufen bei Bearbeitung | Kategorie zuweisen ( von edit_kat_daten_action2.php)
//
//#####################################################################################

if(array_key_exists('pic_id',$_GET))
{
	$pic_id = $_GET['pic_id'];
}
else
{
	$pic_id = 0;
}

if(array_key_exists('kat_liste',$_GET))
{
	$kat_liste = $_GET['kat_liste'];
}
else
{
	$kat_liste = NULL;
}

if(array_key_exists('mod',$_GET))
{
	$mod = $_GET['mod'];
}
else
{
	$mod = 0;
}

$error_code = 0;

include '../../share/global_config.php';
include $sr.'/bin/share/db_connect1.php';
include $sr.'/bin/share/read_session_prefs.php';
include $sr.'/bin/share/functions/main_functions.php';

$result0 = mysqli_query($conn, "SELECT * FROM $table1 WHERE id = '$uid' AND aktiv = '1'");
$row0 = mysqli_fetch_assoc($result0);
$username = $row0['username'];

$exiftool = buildExiftoolCommand($sr);

$kat_array = array();
$kat_array = explode(",", $kat_liste);


//++++++++++++++++++++++++++++++++++++++++++++++++++

// HINWEIS: Wenn einem Objekt eine Kategorie zugewiesen werden soll, 
// werden ihm gleichzeitig alle Eltern-Kategorien mit zugewiesen, 
// denn ein Motiv in Blankenburg ist zwangslaeufig in Sachsen-Anhalt, 
// der BRD und Europa...

//++++++++++++++++++++++++++++++++++++++++++++++++++

//Fuer alle Elemente in dem Ziel-Kategorie-Array werden alle zugehoerigen Eltern-Elemente bestimmt und ebenfalls in das Array geschrieben:
if (isset($kat_array) AND count($kat_array) > 0)
{
	foreach($kat_array AS $kat_id)
	{
		while ($kat_id > '1')
		{
			$res0 = mysqli_query($conn, "SELECT parent FROM $table4 WHERE kat_id='$kat_id'");
			$row0 = mysqli_fetch_assoc($res0);
			$kat_id = $row0['parent'];
			//echo "Kat-ID in der Funktion: ".$kat_id."<br />";
			$KAT_ID[]=$kat_id; //$KAT_ID: Array mit den Eltern-Elementen
		}
	}
}
//Zufuegen aller Eltern-Elemente zu dem Kategorien-Array: ($kat_id beinhaltet alle neu zuzuweisenden Kategorien für das Objekt pic_id)
@$kat_array = array_merge($kat_array, $KAT_ID);
//echo "Kategorie-Anzahl: ".count($kat_array)."<br />";

// Welche Kategorie-Zuweisung gibt es bisher für Objekt 'pic_id'?
if (isset($pic_id) AND count($kat_array) > 0)
{
    $kategorie = '';
    $kategorie_iptc = '';
    
    $res0 = mysqli_query($conn, "SELECT kat_id FROM $table10 WHERE pic_id = '$pic_id' AND kat_id <> '1'");
    if (mysqli_num_rows($res0) > '0')
    {
        $num0 = mysqli_num_rows($res0);
        for($i0=0; $i0<$num0; $i0++)
        {
            // dem Array neuer Kat-IDs werden die bereits zugewiesenen Kat-IDs hinzugefügt
            $row0 = mysqli_fetch_assoc($res0);
            $kat_id = $row0['kat_id'];
            $kat_array[] = $kat_id;
        }
    }

    // nun können die Kat.-Zuweisungen aus der Tabelle pic_kat für das Objekt pic_id gelöscht und anschließend neu geschrieben werden:
    $res1 = mysqli_query($conn, "DELETE FROM $table10 WHERE pic_id = '$pic_id'");
    foreach($kat_array AS $kat_id)
    {
       $res1 = mysqli_query($conn, "INSERT INTO $table10 (kat_id, pic_id) VALUES ('$kat_id', '$pic_id')");
        // gleichzeitig werden die Kategorien im Klartext ermittelt für den Meta-Daten-Eintrag und die pictures.keywords:
        $res2 = mysqli_query($conn, "SELECT kategorie FROM $table4 WHERE kat_id = '$kat_id'");
        $row2 = mysqli_fetch_assoc($res2);
        // Vermeidung mehrfacher Speicherung von Kategorienamen im IPTC-Tag und der Tabelle pictures.keywords
        if( !strstr($kategorie, $row2['kategorie']))
        {
            $kategorie = $row2['kategorie'].", ".$kategorie;
        }
    }
    // Log-Datei schreiben:
    $fh = fopen($p2b_path.'/pic2base/log/p2b.log','a');
    flock($fh, LOCK_EX);
    fwrite($fh,date('d.m.Y H:i:s').": Kategoriezuordnung von Objekt ".$pic_id." wurde von ".$username." modifiziert. (Zugriff von ".$_SERVER['REMOTE_ADDR']."\nneu: ".$kategorie."\n");
    flock($fh, LOCK_UN);
    fclose($fh);
    
    // pictures.keywords aktualisieren
    // Keywords wird auf max. 250 Zeichen (Feldlänge in Tabelle pictures) gekürzt:
    $db_kw = substr($kategorie,'0','249');
    $res3 = mysqli_query($conn, "UPDATE $table2 SET Keywords = '$db_kw', has_kat = '1' WHERE pic_id = '$pic_id'");
    // Metadaten (keywords) des Objektes 'pic_id' aktualisieren
    $FN = strtolower($pic_path."/".restoreOriFilename($pic_id, $sr));
    
    if(strlen($kategorie) > 64)
    {
        // Da immer nur 64 Zeichen lange Blöcke in einem Zug nach IPTC:Keywords geschrieben werden können, wird $kategorie hier gesplittet:
        writeIptcKeywords($pic_id, $kategorie, $sr);
    }
    else 
    {
        $exiftool = buildExiftoolCommand($sr);
        $command = $exiftool." -IPTC:Keywords=\"$kategorie\" -overwrite_original ".$FN;
        shell_exec($command);
    }

	if (mysqli_errno($conn) == '0')
	{
		$error_code = 0;
		$errorStr = 0;
	}
	else
	{
		$error_code = 1;
		$errorStr = mysqli_error($conn);
	}
}
else
{
	$error_code = 2; 
}
mysqli_close($conn);

$obj1 = new stdClass();
$obj1->errorCode = $error_code;
//$obj1->errorStr = $errorStr;
$obj1->Userid = $uid;
$obj1->mod = $mod;
$output = json_encode($obj1);
echo $output;
?>