<?php
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
// Verwendung bei der Bearbeitung / Kategoriezuweisung aufheben (Auswahl nach Kategorien)
// Skript entfernt bei jedem Objekt (pic_id) die gewaehlte Kategorien (kat_id) icl. Unter-Kategorien
// ist $del_all_kat == 1, werden alle Kategoriezuweisungen entfernt
// wird aufgerufen bei Bearbeitung | Kategorie-Zuweisung aufheben (von remove_kat_daten_action2.php)
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
 * Project: pic2base
 * File: update_kat_remove_.php
 *
 * Copyright (c) 2005 - 2021 Klaus Henneberg
 *
 * Project owner:
 * Dipl.-Ing. Klaus Henneberg
 * 38889 Blankenburg, BRD
 *
 * This file is licensed under the terms of the Open Software License
 * http://www.opensource.org/licenses/osl-2.1.php
 */

if(array_key_exists('pic_id',$_GET))
{
	$pic_id = $_GET['pic_id'];
}
else
{
	$pic_id = 0;
}

if(array_key_exists('kat_id',$_GET))
{
	$kat_id = $_GET['kat_id'];
}
else
{
	$kat_id = NULL;
}

if(array_key_exists('mod',$_GET))
{
	$mod = $_GET['mod'];
}
else
{
	$mod = 0;
}

if(array_key_exists('del_all_kat',$_GET))
{
    $del_all_kat = $_GET['del_all_kat'];
    //echo "del: ".$del_all_kat."<br />";
    if($del_all_kat == 'on' OR $del_all_kat == 1)
    {
        $del_all_kat = 1;
    }
    else
    {
        $del_all_kat = 0;
    }
}
else 
{
    $del_all_kat = 0;
}
//echo "Objekt-ID: ".$pic_id.", Kat-ID: ".$kat_id.", Mod.: ".$mod.", Alle Kat. löschen?: ".$del_all_kat."<br />";
$error_code = 0;

include '../../share/global_config.php';
include $sr.'/bin/share/db_connect1.php';
include $sr.'/bin/share/read_session_prefs.php';
include $sr.'/bin/share/functions/main_functions.php';

$result0 = mysqli_query($conn, "SELECT * FROM $table1 WHERE id = '$uid' AND aktiv = '1'");
$row0 = mysqli_fetch_assoc($result0);
$username = $row0['username'];

$exiftool = buildExiftoolCommand($sr);

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//HINWEIS: Wenn eine Kategorie entfernt werden soll, werden gleichzeitig alle Child-Kategorien mit entfernt...

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// sollen ggf. alle Kategorie-Zuweisungen aus dem Objekt entfernt werden?

if(isset($pic_id) AND isset($kat_id) AND isset($del_all_kat) AND $del_all_kat == 1)
{
    $result1 = mysqli_query($conn, "DELETE FROM $table10 WHERE (pic_id = '$pic_id')");
    $result2 = mysqli_query($conn, "UPDATE $table2 SET has_kat = '0', Keywords = '' WHERE pic_id = '$pic_id'");
    $FN = strtolower($pic_path."/".restoreOriFilename($pic_id, $sr));
    $command = $exiftool." -IPTC:Keywords='' -overwrite_original ".$FN;
    shell_exec($command);
    $fh = fopen($p2b_path.'/pic2base/log/p2b.log','a');
    flock($fh, LOCK_EX);
    fwrite($fh,date('d.m.Y H:i:s').": Kategoriezuordnung von Objekt ".$pic_id." wurde von ".$username." vollständig aufgehoben. (Zugriff von ".$_SERVER['REMOTE_ADDR'].")");
    flock($fh, LOCK_UN);
    fclose($fh);
    //$error_code = 0;
}

ELSEIF ( isset($pic_id) AND isset($kat_id) AND isset($del_all_kat) AND $del_all_kat == 0)
{
	function getTree($kat_id,$pic_id) 
	{
	    include '../../share/global_config.php';
		include $sr.'/bin/share/db_connect1.php';
		$result2 = mysqli_query($conn, "SELECT kat_id, kategorie FROM $table4 WHERE parent='".$kat_id."' ORDER BY kategorie");
	    while($einzeln = @mysqli_fetch_assoc($result2)) 
	    {
	      if(hasChildKats($einzeln['kat_id'],$pic_id)) 
	      {
	        $KA = $einzeln['kat_id'];
	        $result3 = mysqli_query($conn, "DELETE FROM $table10 WHERE pic_id = '$pic_id' AND kat_id = '$KA'");
	       	$KAE = getTree($einzeln['kat_id'],$pic_id);
	      } 
	      else 
	      {
	        $KA = $einzeln['kat_id'];
	        $result4 = mysqli_query($conn, "DELETE FROM $table10 WHERE pic_id = '$pic_id' AND kat_id = '$KA'");
	      }
	    }
	}
	
	function hasChildKats($katID,$pic_id) 
	{
	    include '../../share/global_config.php';
		include $sr.'/bin/share/db_connect1.php';
		$result5 = mysqli_query($conn, "SELECT kat_id FROM $table4 WHERE parent='".$katID."'");
	    if(mysqli_num_rows($result5)>0) return true; else return false;
	}		
			
//	########################################
	
	$result1 = mysqli_query($conn, "DELETE FROM $table10 WHERE pic_id = '$pic_id' AND kat_id = '$kat_id'");
	echo mysqli_error($conn);

	$KA = getTree($kat_id,$pic_id);
	
	//Kontrolle, ob dem Objekt noch mindestens eine Kategorie zugewiesen ist, sonst: has_kat = 0
	$result6 = mysqli_query($conn, "SELECT * FROM $table10 WHERE pic_id = '$pic_id'");
	$num6 = mysqli_num_rows($result6);

	$FN = strtolower($pic_path."/".restoreOriFilename($pic_id, $sr));

	IF($num6 == '1')
	{
		$result6_1 = mysqli_query($conn, "DELETE FROM $table10 WHERE pic_id = '$pic_id'");
		$result7 = mysqli_query($conn, "UPDATE $table2 SET has_kat = '0' WHERE pic_id = '$pic_id'");
		echo mysqli_error($conn);
	}
	ELSE
	{
		if ( !isset($kw) )
		{
			$keywords = '';
		}
		
		$result8 = mysqli_query($conn, "SELECT $table10.pic_id, $table10.kat_id, $table4.kat_id, $table4.kategorie
    	FROM $table4, $table10
    	WHERE $table10.pic_id = '$pic_id'
    	AND $table4.kat_id = $table10.kat_id
    	AND $table4.kat_id <> '1'");
		$num8 = mysqli_num_rows($result8);
		$kategorie = '';
		FOR($i8=0; $i8<$num8; $i8++)
		{
		    $row8 = mysqli_fetch_assoc($result8);
		    $sel_kategorie = $row8['kategorie'];
		    // Feldinhalt fuer die pictures.Keywords-Spalte generieren:
		    $kategorie .= ", ".$sel_kategorie;
		}
		
		// pictures.keywords aktualisieren
		// Keywords wird auf max. 250 Zeichen (Feldlänge in Tabelle pictures) gekürzt:
		$db_kw = substr($kategorie,'0','249');
		$res3 = mysqli_query($conn, "UPDATE $table2 SET Keywords = \"$db_kw\", has_kat = '1' WHERE pic_id = '$pic_id'");
		// Metadaten (keywords) des Objektes 'pic_id' aktualisieren
		
		IF(strlen($kategorie) > 64)
		{
		    // Da immer nur 64 Zeichen lange Blöcke in einem Zug nach IPTC:Keywords geschrieben werden können, wird $kategorie hier gesplittet:
		    writeIptcKeywords($pic_id, $kategorie, $sr);
		}
		else
		{
		    $exiftool = buildExiftoolCommand($sr);
		    $command = $exiftool." -IPTC:Keywords=\"$kategorie\" -overwrite_original ".$FN;
		    shell_exec($command);
		}
		
		//Log-Datei schreiben:
		$fh = fopen($p2b_path.'/pic2base/log/p2b.log','a');
		flock($fh, LOCK_EX);
		fwrite($fh,date('d.m.Y H:i:s').": Kategoriezuordnung von Objekt ".$pic_id." wurde von ".$username." modifiziert. (Zugriff von ".$_SERVER['REMOTE_ADDR']."\nneu: ".$kategorie."\n");
		flock($fh, LOCK_UN);
		fclose($fh);

		echo mysqli_error($conn);	
	}

	IF (mysqli_errno($conn) == '0')
	{
		$error_code = 0;
	}
	ELSE
	{
		$error_code = 1;
	}
}
ELSE
{

	$error_code = 2; 
}
mysqli_close($conn);

$obj1 = new stdClass();
$obj1->errorCode = $error_code;
$obj1->Userid = $uid;
$obj1->mod = $mod;
$obj1->del_all_kat = $del_all_kat;
$obj1->parent = $kat_id;
$output = json_encode($obj1);
echo $output;
?>