function MapCameraCircle()
{
	this.map = null;
	this.center = new google.maps.LatLng(0, 0);
	this.radius = 30;
	this.mapZoom = 1;
  
	this.options = 
	{
		strokeColor: '#FF0000',
		strokeOpacity: 0.8,
		strokeWeight: 2,
		fillColor: '#FF0000',
		fillOpacity: 0.35,
		map: null,
		center: new google.maps.LatLng(0, 0)
  	};
	this.mapObj = new google.maps.Circle( this.options );
	
	var innerSymbolOptions = 
	{
      	strokeColor: '#0000FF',
      	strokeOpacity: 0.8,
      	strokeWeight: 2,
      	fillColor: '#000000',
      	fillOpacity: 0.35,
      	map: null,
      	center: new google.maps.LatLng(0, 0),
      	radius: 2
    };
	this.mapCameraPoint = new google.maps.Circle( innerSymbolOptions );
};

MapCameraCircle.prototype.setMap = function( map )
{
  this.map = map;
  this.mapObj.setMap( map );
  this.mapCameraPoint.setMap( map );
  this.mapZoom = map.getZoom();
  var objCircle = this;
  google.maps.event.addListener(map, 'zoom_changed', function() {
	  objCircle.mapZoom = map.getZoom();
	  objCircle.updateGeometry();
  });

  this.updateGeometry();
};

MapCameraCircle.prototype.setCenter = function( lat, lon )
{
	this.mapObj.setCenter( new google.maps.LatLng(lat, lon) );
	this.mapCameraPoint.setCenter( new google.maps.LatLng(lat, lon) );
};

MapCameraCircle.prototype.setRadius = function( r )
{
  this.radius = r;
  this.updateGeometry();
};

MapCameraCircle.prototype.updateGeometry = function()
{
	this.mapObj.setRadius( this.radius * 30000.0 / Math.pow( 2, this.mapZoom ) );
	this.mapCameraPoint.setRadius( 2 * 30000.0 / Math.pow( 2, this.mapZoom ) );
};