<!DOCTYPE html>
<html lang="ge">
  <head>
    <title>pic2base :: Jahrbücher</title>
    <link rel='shortcut icon' href='../../share/images/favicon.ico'>
    <script type='text/javascript' src='../../share/functions/ShowPicture.js'></script>
    <script type='text/javascript' src='../../ajax/inc/prototype.js'></script>
    <script type='text/javascript' src='../../share/functions/jquery-3.2.1.min.js'></script>
    <script type='text/javascript' src='../../share/functions/jquery.lazy.js'></script>
    <script type='text/javascript'>
      jQuery.noConflict();
    </script>
  </head>

<?php

/*########################################################################################
 * Project: pic2base
 * File: show_all.php
 * 
 * Suche - Jahrbuch-Ansicht (mit lazy loading)
 *
 * Copyright (c) 2005 - 2023 Klaus Henneberg
 *
 * Project owner:
 * Dipl.-Ing. Klaus Henneberg
 * 38889 Blankenburg, BRD
 *
 * This file is licensed under the terms of the Open Software License
 * http://www.opensource.org/licenses/osl-2.1.php
 ########################################################################################*/

 echo "<link rel=stylesheet type='text/css' href='../../css/format1.css'>
 <link rel=stylesheet type='text/css' href='../../css/main.css'>";
 include '../../share/global_config.php';
 include $sr.'/bin/share/db_connect1.php';
 include $sr.'/bin/share/read_session_prefs.php';
 require_once $sr.'/bin/share/functions/main_functions.php';
 require_once $sr.'/bin/share/functions/ajax_functions.php';

 if(array_key_exists('jb_step',$_GET))
 {
   $jb_step = $_GET['jb_step'];
 }
 else
 {
   $jb_step = 0;
 }

// gibt es in der users-Tabelle einen Eintrag für den zuletzt angesehenen Objekt-Jahrgang der Bilderbuch-(Timeline-)Ansicht?
// ... dann stelle den Slider auf dieses Jahr:
$result2 = mysqli_query($conn, "SELECT last_used_timeline_year FROM $table1 WHERE id = '$uid'");
echo mysqli_error($conn);
$row2 = mysqli_fetch_assoc($result2);
$last_used_timeline_year = $row2['last_used_timeline_year'];  //echo "show_all.php. Z. 63: letzte Verwendung: ".$last_used_timeline_year."<br>";

// Es werden das früheste und späteste Aufnahme-Jahr ermittelt.
// und: Es werden nur Objekte mit vorhandenem Erstellungsdatum berücksichtigt!
$stat = "SELECT MAX(DATE_FORMAT(CreateDate, '%Y')) AS max_datum, MIN(DATE_FORMAT(CreateDate, '%Y')) AS min_datum 
FROM $table2
WHERE (DATE_FORMAT(CreateDate, '%Y') IS NOT NULL
AND DATE_FORMAT(CreateDate, '%Y') <> ''
AND DATE_FORMAT(CreateDate, '%Y') <> '0000')";

$result0 = mysqli_query($conn, $stat);
$row0 = mysqli_fetch_assoc($result0);
$max_datum = $row0['max_datum'];
$min_datum = $row0['min_datum'];
//echo "spätestes Jahr: ".$max_datum.", frühestes Jahr: ".$min_datum."<br>";
if($last_used_timeline_year == '0000')
{
  $last_used_timeline_year = $max_datum;
}
//echo $last_used_timeline_year."<br>";
echo "<body style='background-color:var(--bgcolor5);height:100%;overflow-y:scroll;'>
        <div class='timeline_grid'>

          <div id='timeline_head' class='timeline_head' style='align-items: center;'>";

            if($search_modus == 'collection')
            {
              echo "<div class='timeline_year' style='cursor:pointer;' id='search_modus' title='Klick wechselt zum Normal-Modus' onClick='alterSearchModus(\"collection\");'>Kollektionsmodus</div>";
            }
            elseif($search_modus == 'normal')
            {
              echo "<div class='timeline_year' style='cursor:pointer;' id='search_modus' onClick='alert(\"Sie befinden sich im normalen Suchmodus. Ein Wechsel in den Kollektionsmodus ist nur über Bearbeitung - Kollektionen (mit entsprechender Berechtigung) möglich.\")'>Normale Suche</div>";
            }
            
            echo "
            <div style='width:450px;'>
              <span id='min_year' class='timeline_min_year'>".$min_datum."</span>
                <input type='range' min='$min_datum' max='$max_datum' value='$last_used_timeline_year' class='timeline_slider' id='timeline_start' 
                onMouseOver='this.focus()'; onMouseOut='this.blur()'; onChange=\"saveTimelineStartYear(timeline_start.value, '0', '$step_width', '$uid', '$sr');\" title='Wählen Sie hier das gewünschte Jahr aus.' />
              <span id='max_year' class='timeline_max_year'>".$max_datum."</span>
            </div>

            <div class='timeline_year' id='timeline_year'>Aktuelles Jahr</div>

          </div>


          <div class='timeline_navigation'>";
            createNavi2_1($uid); //echo $jb_step."<br>".$step_width;
          echo "</div>


          <div class='timeline_content'>
            <div class='content_left' id='pictures'>";
              getTimelinePreviewContent($last_used_timeline_year, $jb_step, $step_width, $uid, $sr);
            echo "</div>
          </div>


          <div id='info' class='content_right'>
            <p style='text-align:center; font-size:12px; color:var(--color_g); margin-top:50px;'>Zur Anzeige der Objekt-Details klicken Sie bitte auf das entsprechende Vorschaubild.</p>
          </div>
          

          <div class='timeline_foot'>
            <a style='position:relative; top:8px; left:10px; font-size:10px; color:var(--color1);' HREF='http://www.pic2base.de' target='blank'>www.pic2base.de</a>
          </div>

        </div>

  <div id='blend' style='display:none; z-index:9999;'>
    <img src='../../share/images/grey.png' style='z-index:10000; position:absolute; top:0px; left:0px; width:100%; height:100%;' />
    <img src=\"../../share/images/loading.gif\" style='position:absolute; top:30%; left:50%; width:20px; z-index:10001;' />
  </div>";
?>

<script type=text/javascript>

  function assignTimelineLazyLoading()
  {
    jQuery(function() {
        jQuery('.lazy').Lazy({
            scrollDirection: 'vertical',
            effect: 'fadeIn',
            visibleOnly: true,
            onError: function(element) {
                console.log('error loading ' + element.data('src'));
            }
        });
    });
  }
  assignTimelineLazyLoading();

  function showPreview(object,media_type)
  {
    document.getElementById('preview').style.visibility = 'visible';
    
    if(media_type == 'i')
    {
      //alert("Bild: " + object);
      document.getElementById('preview').innerHTML='<img src=' + object + ' width=100% height=100% style=\"object-fit:contain;\">';
    }
    else if(media_type == 'v')
    {
      //alert("Video: " + object);
      document.getElementById('preview').innerHTML='<video id=vid_id controls width=80% height=80% style=\"margin-top:100px;object-fit:contain;\"><source src=' + object + ' type=\"video/webm\"></video>';
    }
    else if(media_type == 'a')
    {
      //alert("Audio: " + object);
      document.getElementById('preview').innerHTML='<div style=\"width:100%; height:50%; display:flex; justify-content:center;\">'
      + '<audio controls autoplay style=\"border-style:solid; border-color:grey; width:50%; height:40px; margin-top:100px;object-fit:contain;\">'
      + '<source src=' + object + ' type=\"audio/mp3\">'
      + '</audio>'
      + '</div>';
    }
  }

  function hidePreview()
  {
    if(document.getElementById('vid_id'))
    {
      document.getElementById('vid_id').pause();
    }
    document.getElementById('preview').style.visibility='hidden';
  }

  // Behandlung des Slider-Events
  var timeline_start = document.getElementById("timeline_start"); // Slider-Wert
  var output = document.getElementById("timeline_year");          // Slider-Überschrifts-Bereich
  output.innerHTML = "Aktuelles Jahr: " + timeline_start.value;   // Inhalt der Überschrift
  
  // Update des aktuellen Slider-Wertes bei jeder Änderung
  timeline_start.oninput = function() 
  {
    output.innerHTML = "Aktuelles Jahr: " + this.value;
  }

  function showDelWarning(pic_id)
  {
      var check = confirm("Wollen Sie das Objekt wirklich entfernen?");
      if(check == true)
      {
        window.open('../../share/delete_picture.php?pic_id=' + pic_id, 'Delete', 'width=600px, height=450px');
      }
  }

  // Behandlung von Tastatur-Eingaben um im Objekt-Bestand vor und zurück navigieren zu können:
  var elem = document.querySelector('body');
  elem.addEventListener("keydown", TasteGedrückt );
  function TasteGedrückt (evt) 
  {
	  let zeichen = String.fromCharCode(evt.charCode);
    var jb_step = <?php echo $jb_step?>; 
    var max_steps = document.getElementById('max_steps').value;
    
      var step_n = jb_step + 1;
      var step_p = jb_step - 1;
      if(evt.key == 'ArrowLeft')
      {
        //alert("Taste links");
        if(step_p >= 0)
        {
          location.href='../recherche/show_all.php?jb_step=' + step_p;
        }
        else
        {
          // Übergang zum Vorjahr
          var min_year = document.getElementById("min_year").innerText;
          var year = document.getElementById("timeline_start").value;
          var uid = <?php echo $uid?>;
          var sr = <?php echo "'$sr'"?>; 
          if(year > min_year)
          {
            showPrevYear(year, uid, sr);
          }
          else
          {
            alert("Es existiert kein früherer Jahrgang.");
          }
        }
      }
      else if(evt.key == 'ArrowRight')
      {
        //alert("Taste rechts");
        if(jb_step < max_steps)
        {
          location.href='../recherche/show_all.php?jb_step=' + step_n;
        }
        else
        {
          // Übergang zum nächsten Jahr:
          var max_year = document.getElementById("max_year").innerText;
          var year = document.getElementById("timeline_start").value;
          var uid = <?php echo $uid?>; 
          var sr = <?php echo "'$sr'"?>; 
          if(year < max_year)
          {
            showNextYear(year, uid, sr);
          }
          else
          {
            alert("Es existiert kein späterer Jahrgang.");
          }
        }
      }
  }
</script>
</body>
</html>