<?php

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Project: pic2base
 * File: show_map.php
 *
 * Copyright (c) 2005 - 2021 Klaus Henneberg
 *
 * Project owner:
 * Dipl.-Ing. Klaus Henneberg
 * 38889 Blankenburg, BRD
 *
 * This file is licensed under the terms of the Open Software License
 * http://www.opensource.org/licenses/osl-2.1.php
 * 
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

 //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //
 // wird verwendet, wenn bei einer Suche auf das OSM-Symbol geklickt wird
 //
 //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


echo "<link rel=stylesheet type='text/css' href='../../css/format2.css'>";
include '../../share/global_config.php';
include $sr.'/bin/share/db_connect1.php';
include $sr.'/bin/share/read_session_prefs.php';
include $sr.'/bin/share/functions/main_functions.php';

$ol_css = "../../share/ol_5.3.0/ol.css";
$ol_js = "../../share/ol_5.3.0/ol.js";
//var_dump($_REQUEST);

IF(array_key_exists('width',$_REQUEST))
{
	$width = $_REQUEST['width'];
}
IF(array_key_exists('height',$_REQUEST))
{
	$height = $_REQUEST['height'];
}

IF(array_key_exists('pic_id',$_REQUEST))
{
	$pic_id = $_REQUEST['pic_id'];
}

$result1 = mysqli_query($conn, "SELECT GPSLongitude, GPSLatitude, GPSImageDirection, FieldOfView FROM $table2 WHERE pic_id = '$pic_id'");
echo mysqli_error($conn);
$row1 = mysqli_fetch_assoc($result1);
$gpslong = $row1['GPSLongitude'];   //echo "GPS-Long: ".$gpslong."<br />";
$gpslat = $row1['GPSLatitude'];     //echo "GPS-Lat: ".$gpslat."<br />";
IF($gpslong == '' OR $gpslat == '')
{
    $gpslong = NULL;
    $gpslat = NULL;
}
$gpsimgdir = $row1['GPSImageDirection'];
// Wenn in der DB keine Blickrichtung verzeichnet ist, wird versucht, diese aus dem Bild zu entnehmen
// Wenn das möglich ist, wird die DB aktualisiert
if($gpsimgdir == NULL)
{
    $FN = $pic_path."/".restoreOriFilename($pic_id, $sr); //echo $FN."<br /><br />";
    $exiftool = buildExiftoolCommand($sr);
    $gpsimgdir = trim(shell_exec($exiftool." -c '%.11f' -GPSImgDirection -n -s -s -s ".$FN));
    if($gpsimgdir  == NULL OR is_string($gpsimgdir))
    {
        $gpsimgdir = 999;                                                                            // willkuerlicher Dummy-Wert
    }
    else 
    {
        $gpsimgdir = number_format($gpsimgdir,2);
        $result2 = mysqli_query($conn, "UPDATE $table2 set GPSImageDirection = '$gpsimgdir' WHERE pic_id = '$pic_id'");
    }
}
$fov = $row1['FieldOfView'];
// Wenn in der DB kein Bildfeld verzeichnet ist, wird versucht, diese aus dem Bild zu entnehmen
// Wenn das möglich ist, wird die DB aktualisiert
if($fov == NULL)
{
    $FN = $pic_path."/".restoreOriFilename($pic_id, $sr); //echo $FN."<br /><br />";
    $exiftool = buildExiftoolCommand($sr);
    $fov_arr = explode(" ", shell_exec($exiftool." -c '%.11f' -FOV -n -s -s -s ".$FN));
    $fov = trim($fov_arr[0]);
    // es kann ja sein, dass der Oeffnungswinkel nicht bekannt ist (z.B. bei Scans):
    IF($fov == NULL)
    {
        $fov = 0;
    }
    else
    {
        $fov = number_format($fov,2);
        $result2 = mysqli_query($conn, "UPDATE $table2 set FieldOfView = '$fov' WHERE pic_id = '$pic_id'");
    }
}
//echo "GPS-Long: ".$gpslong."<br />GPS-Lat: ".$gpslat."<br />Blickrichtung: ".$gpsimgdir."°<br />Blickfeld: ".$fov."°<br />";
?>

<html>
<head>
<title>pic2base :: Kamera-Standort</title>
</head>

<body style='background-color:var(--bgcolor2);'>
  <div id="map" class = "map" onDblClick='window.close()' title='Doppelklick in die Karte schließt das Fenster';></div>
  <center>
  </center>
  
  <style>
  .map {
    height: 100%;
    width: 100%;
    cursor: pointer;
  }
  </style>
  
  <link rel="stylesheet" href="<?php echo $ol_css;?>" type="text/css"></link>
  <script src="<?php echo $ol_js;?>"></script>
  
      <script type='text/javascript'>
      //Berechnung der Richtungskoordinaten
      var lat = "<?php echo $gpslat;?>";
      var lon = "<?php echo $gpslong;?>";
      //alert("Lat-Länge: " + lat.length);
      if(lat.length > 0 && lon.length > 0)
      {
        lat = parseFloat(lat);	//alert("Lat: " + lat);
        lon = parseFloat(lon);	//alert("Lon: " + lon);
        
        var length = 50000;
        var gpsimgdir = <?php echo $gpsimgdir;?>;
          
        var coordStart = ol.proj.transform([lon, lat], 'EPSG:4326', 'EPSG:3857');					// Koordinaten-Transformation von WGS84 (GPS) nach Pseudo-Mercator
        if(gpsimgdir !== 999)
        {
             // alert("Blickrichtung vorhanden");
                var fov = <?php echo $fov;?>;
            var dir1 = gpsimgdir + fov/2;
            var dir2 = gpsimgdir - fov/2;  														// alert(dir1 + " / " + dir2);
            var lon1_end = coordStart[0] + (Math.sin(dir1 * Math.PI / 180.0) * length);
            var lat1_end = coordStart[1] + (Math.cos(dir1 * Math.PI / 180.0) * length);
            var lon2_end = coordStart[0] + (Math.sin(dir2 * Math.PI / 180.0) * length);
            var lat2_end = coordStart[1] + (Math.cos(dir2 * Math.PI / 180.0) * length);
            var coordEnd1 = ol.proj.transform([lon1_end, lat1_end], 'EPSG:3857', 'EPSG:4326');
            var coordEnd2 = ol.proj.transform([lon2_end, lat2_end], 'EPSG:3857', 'EPSG:4326');	// Rücktransformation nach WGS84
            var lon1 = coordEnd1[0];
            var lat1 = coordEnd1[1];
            var lon2 = coordEnd2[0];
            var lat2 = coordEnd2[1];
            
            var linestring_feature = new ol.Feature({												// Linie erzeugen
              geometry: new ol.geom.LineString(
                [[lon1, lat1], [lon, lat], [lon2, lat2]]										// Verlauf der Linie wird durch 3 Punkte bestimmt
              )
            });	
        }
        else
        {
          // alert("Blickrichtung nicht vorhanden");
          var linestring_feature = new ol.Feature({												// Dummy-Linie erzeugen
        	  geometry: new ol.geom.LineString(
        	    [[lon, lat], [lon, lat]]														// 2 gleiche Koordinaten erzeugen KEINE Linie, nur einen Punkt
        	  )
        	});	
        }
																									// alert("Standort: " + lon + " / " + lat + ";\nRichtung 1: " + lon1 + " / " + lat1 + ";\nRichtung 2: " + lon2 + " / " + lat2);

          var map = new ol.Map({ });
          map.setTarget('map');
    
          var tile_layer = new ol.layer.Tile({														// hinzufügen einer neuen Ebene (Tile-Layer -> Kachel-Ebene)
        	  source: new ol.source.OSM({layer: 'osm'})												// Quelle der Ebene ist OSM
        	})
          map.addLayer(tile_layer);																	// der Karte wird die Ebene hinzugefügt
          map.getView().setZoom(14);																// Ansicht auf Zoom-Stufe (14) setzen
          map.getView().setCenter(coordStart);														// Zentrum der Ansicht auf Koordinaten des Bildes setzen
    		
          var point_feature = new ol.Feature({ });													// Punkt erzeugen
          var point_geom = new ol.geom.Point(														// dem Punkt die Koordinaten zuweisen
          		  [lon, lat]
          		);
          point_feature.setGeometry(point_geom);
    
          var vector_layer = new ol.layer.Vector({													// es wird eine neue Vektor-Ebene erzeugt, und
        	  source: new ol.source.Vector({
        	    features: [point_feature, linestring_feature]										// der Punkt und die Rchtungs-Striche gezeichnet
        	  })
        	})
        	map.addLayer(vector_layer);																// diese Ebene wird auf der Karte platzeiert

        var features = [
        	  point_feature, 
        	  linestring_feature
        	];

        function transform_geometry(element) 
        {
            var current_projection = new ol.proj.Projection({code: "EPSG:4326"});
            var new_projection = tile_layer.getSource().getProjection();
            element.getGeometry().transform(current_projection, new_projection);
        }
    
        features.forEach(transform_geometry);
    
          var fill = new ol.style.Fill({															// Aussehen der Füllung wird festgelegt
        	  	color: [0, 0, 225, 0.2]
        	});
        	 
          var stroke = new ol.style.Stroke({														// Aussehen der Linie wird festgelegt
         		color: [0, 0, 255, 0.8],
          		width: 1
          	});
    
          var style = new ol.style.Style({															// Anwendung der Styles: Punkt als Kreis mit Radius, Füllung und Linie
        	  image: new ol.style.Circle({
        	    fill: fill,
        	    stroke: stroke,
        	    radius: 8
        	  }),
        	  fill: fill,
        	  stroke: stroke
        	});
          vector_layer.setStyle(style);
      }																// Styles der Vektor-Ebene zuweisen
      else
      {
        //alert("Das Objekt enthält keine gültigen Geo-Koordinaten!");
        document.getElementById('map').innerHTML = "<center><p style='margin-top:150px; font-family:Helvitica,Arial; font-size:10pt;'>Das Objekt besitzt keine gültigen Geo-Koordinaten.</p>"+
        "<input type='button' id='button1' value='Fenster schließen (Enter)' onClick='window.close()'></center>";
        document.getElementById('button1').focus();
        document.getElementById('map').style.height = '70px';
        document.getElementById('map').style.backgroundColor = 'yellow';
        document.getElementById('map').style.width='100%';
      }
      </script>
      
</body>
</html>


