<?php
$error = 0;
$file = "";

include 'read_session_prefs.php';
include 'global_config.php';
include $sr.'/bin/share/db_connect1.php';
include $sr.'/bin/share/functions/main_functions.php';

if ( array_key_exists('uid',$_GET) AND $_GET['uid'] !== '')
{
	$uid = $_GET['uid'];
}

if ( array_key_exists('file', $_GET) )
{
    $file = $_GET['file'];
}
else 
{
    $error = 4;
}

/*
 * Eingabegabe-Parameter:
 * $uid - User-ID des angemeldeten Benutzers
*/

$info = pathinfo($file);

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Pruefung, ob Datei den Vorgaben hinsichtlich erlaubter Zeichen im Dateinamen entspricht:
// (einige wenige werden durch Substitution toleriert)
$suchmuster = '/^[A-Za-z0-9_-]+.[a-zA-Z0-9]+$/';
$sonderzeichen = array("ä", "ö", "ü", "Ä", "Ö", "Ü", "ß", " ", chr(63), chr(33), chr(40), chr(41), chr(47), chr(92)); // chr(): ? ! ( ) / \ 
// siehe: https://theasciicode.com.ar/ascii-printable-characters/slash-forward-slash-fraction-bar-division-ascii-code-47.html
$ersetzungen = array("ae", "oe", "ue", "AE", "OE", "UE", "ss", "_", "_", "_", "_", "_", "_", "_");
if(!preg_match($suchmuster, $file))
{
	// Umlaut- und Leerzeichen-Ersetzung:
    $nfn = str_replace ($sonderzeichen,$ersetzungen,$info['basename']); 
	$ren_file = rename($up_dir."/".$file, $up_dir."/".$nfn);
	if($ren_file)
	{
	    $error = 0;
	    $file = $nfn;
	    // Wenn neben Umlauten und Leerzeichen weitere unerlaubte Zeichen enthalten sind, oder der Objektname mehr als 100 Zeichen hat wird Fehlermeldung ausgegeben:
	    if(!preg_match($suchmuster, $file) OR strlen($file) > 99)
	    {
	        $error = 5;
	    }
	}
	else
	{
	    // Auch wenn eine Umbennenung des Objektes nicht möglich ist, wird eine Fehlermeldung ausgegeben:
	    $error = 5;
	}
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//Pruefung, ob Dateityp den Vorgaben hinsichtlich verwendbarer Bild- oder Video-Formate entspricht:
$exiftool = buildExiftoolCommand($sr);
$extension_0 = strtolower($info['extension']);	     //Dateiendung, die das Objekt mitbringt
$Objekt = $up_dir."/".$file;
$cmd = $exiftool." -S -FileType \"".$Objekt."\"";
$ft = preg_split('/ /', shell_exec($cmd));           // $ft -> filetype lt. Exiftool-Erkennung
@$extension = strtolower(trim($ft[1]));		         //Dateityp in Keinschreibweise

// Bei jpg-Dateien wird der Dateityp 'jpeg' identifiziert. Dies wuerde bedeuten, dass praktisch jedes jpg-Objekt umbenannt werden muss
// Zur Vereinfachung wird hier eine Ausnahme hinzugefuegt: jpg-Objekte werden nicht zu jpeg umbenannt!
if(in_array($extension,$supported_filetypes) OR $extension == 'jpg' OR $extension == 'jpeg')
{
    if($extension_0 !== $extension AND $extension_0 !== 'jpg')
    {
        $new_filename = str_replace($extension_0, $extension, $file);
        $ren_file = rename($up_dir."/".$file, $up_dir."/".$new_filename);
        if($ren_file)
        {
            $error = 0;
        }
        else
        {
            $error = 1;
        }
    }
}
else
{
    $error = 2;
}

$obj = new stdClass();
$obj->errorCode = $error;
$obj->file = $file;
$output = json_encode($obj);
echo $output;
?>