<?php

mysqli_connect('localhost', 'pb', 'pic_base');
mysqli_select_db('pic2base');

$resultFeatures = mysqli_query( 'SELECT pic_id, HEX(feature) f FROM features ORDER BY pic_id;' );
echo mysqli_num_rows( $resultFeatures ) . " vectors to compute\n";
$lastPicId = -1;
$dist = 0;

$vectors = array();
$vectorSlices = 20;

function normalizeResultVector( $v )
{
  //var_dump( $v );
  global $vectorSlices;

  $max = 0;
  $scale = 1.0;

  for( $i = 0; $i < $vectorSlices; ++$i )
  {
    $max = max( $max, $v->{'v' . ( $i + 1 )} );
  }
  $scale = 255.0 / $max;
  for( $i = 0; $i < $vectorSlices; ++$i )
  {
    $v->{'v' . ( $i + 1 )} = round( $v->{'v' . ( $i + 1 )} * $scale );
  }
  return $v;
}

function generateVector( $vectors )
{
  global $vectorSlices;
  $res = new stdClass();
  for( $i = 0; $i < $vectorSlices; ++$i )
  {
    $res->{'v' . ( $i + 1 )} = 0;
  }
  foreach( $vectors as $v )
  {
//echo '*';
    for( $i = 0; $i < count( $v->features ); ++$i )
    {
//echo '#';
//echo $v->features[ $i ] . "\n";
      $res->{'v' . ( ( $i % $vectorSlices ) + 1 )} += $v->features[ $i ];
    }
  }
  $res = normalizeResultVector( $res );
  return $res;
}

while( $row = mysqli_fetch_object( $resultFeatures ) )
{
  if( $lastPicId == -1 )
  {
    $lastPicId = $row->pic_id;
  }
  //echo $picId1 . ' <> ' . $lastPicId . "\n";
  $feature = $row->f;
  if( $row->pic_id != $lastPicId )
  {
    //echo 'generating new vector from ' . count( $vectors ) . " vectors\n";
    $resVec = generateVector( $vectors );
    //var_dump( $resVec );
    mysqli_query( 'DELETE FROM pic_feature_vector WHERE pic_id=' . $lastPicId . ';' );
    $sql = 'INSERT INTO pic_feature_vector (pic_id';
    for( $i = 1; $i <= $vectorSlices; ++$i )
    {
      $sql .= ', v' . $i;
    }
    $sql .= ') VALUES (' . $lastPicId;
    for( $i = 1; $i <= $vectorSlices; ++$i )
    {
      $sql .= ', ' . $resVec->{'v' . $i};
    }
    $sql .= ');';
//echo $sql . "\n";
    mysqli_query( $sql );
//echo mysqli_error($conn);
    echo '.';
    $vectors = array();
    $lastPicId = $row->pic_id;
  }
  else
  {
    $v = new stdClass();
    $v->features = array();
    for( $i = 0; $i < 128; ++$i )
    {
      $v->features[] = hexdec(substr( $feature, $i << 1, 2 ));
    }
    $vectors[] = $v;
  }
}