<?php

function getFileError($NUM)
{
	$err = "<font color='green'>Bei der Daten-&Uuml;bernahme gab es keine Fehler.</font><br />";
	SWITCH($NUM)
	{
		CASE UPLOAD_ERR_OK:
		break;
		
		CASE UPLOAD_ERR_INI_SIZE:
		$err = "<font color='red'>Es wurde die in der php-ini festgelegte Dateigr&ouml;&szlig;e &uuml;berschritten!</font>";
		break;
		
		CASE UPLOAD_ERR_FORM_SIZE:
		$err = "<font color='red'>Es wurde die im Formular festgelegte Dateigr&ouml;&szlig;e &uuml;berschritten!</font>";
		break;
		
		CASE UPLOAD_ERR_PARTIAL:
		$err = "<font color='red'>Es wurde nur ein Teil der Datei hochgeladen (Abbruch)!</font>";
		break;
		
		CASE UPLOAD_ERR_NO_FILE:
		$err = "<font color='red'>Es wurde keine Datei hochgeladen!</font>";
		break;
	}
	return $err;
}

function getTrackPoints($delta,$pic_time,$datum)
{
	//Ermittlung aller Trackpunkte im Zeitfenster (Aufnahme-Zeitpunkt +/- delta Sekunden
	include '../../share/global_config.php';
	include $sr.'/bin/share/db_connect1.php';
	$start_time = date('H:i:s', strtotime("$pic_time - $delta seconds"));
	$end_time = date('H:i:s', strtotime("$pic_time + $delta seconds"));
	//echo "Zeitfenster fuer Trackdaten: ".$start_time." - ".$end_time."<br />";
	$result7 = mysqli_query($conn, "SELECT * FROM $table13 WHERE date = '$datum' AND time > '$start_time' AND time < '$end_time'");
	$num7 = mysqli_num_rows($result7);
	//echo "Anz. Trackpunkte: ".$num7."<br />";
	return $num7;
}

function findTrackData($delta,$pic_time,$datum,$pic_id)
{
	//Bestimmung des Trackpunktes mit der kleinsten zeitlichen Abweichung vom Aufnahme-Zeitpunkt:
	include '../../share/global_config.php';
	include $sr.'/bin/share/db_connect1.php';
	IF(!isset($i10))
	{
		$i10 = 0;
	}
	$delta = $delta - 1;
	$start_time = date('H:i:s', strtotime("$pic_time - $delta seconds"));
	$end_time = date('H:i:s', strtotime("$pic_time + $delta seconds"));
	//echo "Zeitgrenzen fuer Trackdaten: ".$start_time." - ".$end_time."<br />";
	$result8 = mysqli_query($conn, "SELECT * FROM $table13 WHERE date = '$datum' AND (time = '$start_time' OR time = '$end_time')");
	$num8 = mysqli_num_rows($result8);
	$row8 = mysqli_fetch_assoc($result8);
	//Wenn mehrere Trackpunkte gefunden werden, werden willkuerlich die Daten des ersten verwendet:
	$longitude = $row8['longitude']; 
	$latitude = $row8['latitude']; 
	$altitude = $row8['altitude']; 
	//Koordinaten werden in der 'pictures' gespeichert:
	$result11 = mysqli_query($conn, "UPDATE $table2 SET GPSLongitude = '$longitude', GPSLatitude = '$latitude', GPSAltitude = '$altitude' WHERE pic_id = '$pic_id'");
}

function gmtToLocalTime($date,$time,$timezone)
{
	//fkt. konvertiert eine GMT-Zeitangabe in die Zeit am Aufnahme-Ort:
	//Version mit manueller Korrektur der Zeitzone:
	//echo $timezone."<br />";
	$akt_date_time = mktime(substr($time,0,2), substr($time,3,2), substr($time,6,2), substr($date,5,2), substr($date,8,2), substr($date,0,4));
	//echo "Aktuelle DateTime: ".$akt_date_time."<br />";
	$korr_time = $akt_date_time + (3600 * $timezone); //Korr. UTC auf lokale Zeit
	$date_time_korr = strftime('%Y-%m-%d %H:%M:%S', $korr_time);
	//echo "korr. Zeit: ".$date_time_korr."<br />";
	return $date_time_korr;
}

function getDeltaLong($lat, $radius1)
{
	$umf_lat = 40000000 * cos(deg2rad($lat));
	//echo "Umfang auf Breitenkreis ".$lat.": ".($umf_lat / 1000)." km<br />";
	$diff_long = 360 / $umf_lat;
	//echo htmlentities("Winkelaeanderung je m: ".$diff_long)." in Grad / m<br />";
	$delta_long = $diff_long * $radius1;
	return $delta_long;
}

function isInCircle($longitude, $long_mittel, $latitude, $lat_mittel, $radius)
{
	//Entfernung pro Breitengrad: 111111,111 m
	$y_abst = pow((($latitude - $lat_mittel) * 111111.111),2); // in qm
	
	//Entfernung je Laengengrad ist von der Erhebung ueber Aequator (Breitengrad) abhaengig:
	$x_abst = pow(($longitude - $long_mittel) * (40000000 * cos(deg2rad($latitude)) / 360),2); //in qm
	//echo $x_abst."<br />";
	
	IF (pow($radius , 2) < ($x_abst + $y_abst))
	{
		$inside = 'false';
	}
	ELSE
	{
		$inside = 'true';
	}
	return $inside;
}

function deg2dec($value)
{
	//Fkt konvertiert die Geo-Koordinaten von Grad/Minute/Sekunde nach dezimaler Schreibweise
	return $value;
}

function convertFile($sr,$data_logger,$info,$geo_file_name,$uid,$timezone)
{
	include $sr.'/bin/share/global_config.php';
	include $sr.'/bin/share/db_connect1.php';
	//include $sr.'/bin/share/functions/main_functions.php';
	
	$gpsbabel = buildGpsbabelCommand($sr);
	$v_gb = shell_exec("gpsbabel -V");
	
	$error = 0;
	//Sony-CS1-log-Dateien werden von GPSBabel als nmea verarbeitet!
	switch($data_logger)
	{
		// Bsp: gpsbabel -t -i nmea -f "Pfad/Datei.log" -o kml -F "Pfad/Datei.kml"
		case '1':
		//Routine fuer Sony CS1 (log)
		if(strtolower($info['extension']) !== 'log')
		{
			echo "Es handelt sich nicht um eine SONY-CS1-Datei!<br />";
			$error = '1';
		}
		else
		{
			$file_format = 'nmea';
		}
		break;
		
		CASE '2':
		//Routine fuer Garmin GPSmap 60CS(x) tracklogs (.gpx)
		if(strtolower($info['extension']) !== 'gpx')
		{
			echo "Es handelt sich nicht um eine Garmin GPSmap 60CS(x)-Datei!<br />";
			$error = '1';
		}
		else
		{
			$file_format = 'gpx';
		}
		break;
		
		case '5':
		//Routine fuer Alan Map500 tracklogs (.trl)
		
		break;
		
		case '6':
		//Routine fuer CarteSurTable data file
		
		break;
		
		case '17':
		//Routine fuer Garmin MapSource (gdb)
		if(strtolower($info['extension']) !== 'gdb')
		{
			echo "Es handelt sich nicht um eine Garmin MapSource-Datei!<br />";
			$error = '1';
		}
		else
		{
			$file_format = 'gdb';
		}
		break;
		
		case '22':
		//Routine fuer Google Earth (Keyhole) Markup Language (kml)
		if(strtolower($info['extension']) !== 'kml')
		{
			echo "Es handelt sich nicht um eine Google Earth (Keyhole) Markup Language-Datei!<br />";
			$error = '1';
		}
		else
		{
			$file_format = 'kml';
		}
		break;
	}
	
	if($error !== '1')
	{
		// #############################################################################################
		//Die p2b-trackfile.kml wird nur als strukturierte Zwischenablage verwendet,aus
		//der die Geo-Daten in die Datenbank ueberfuehrt werden!
		// #############################################################################################
	    
	    $command = "export LD_LIBRARY_PATH=$(dirname $(locate libaa.so | head -1)) && gpsbabel -t -i ".$file_format." -f ".$geo_file_name." -o kml -F ".$user_dir."/kml_files/p2b-trackfile.kml 2>&1";
		$kml_file = shell_exec($command);

		@$fh1 = fopen($user_dir."/kml_files/p2b-trackfile.kml", 'r');
		if(!$fh1)
		{
			echo "<p style='color:yellow; margin-top:50px; font-size:14px;'>Es ist ein Fehler bei der Datenkonvertierung aufgetreten.<br />
			Die weitere Bearbeitung wird abgebrochen.<br /><br />Achten Sie auch darauf, daß die Trackdatei einen gültigen Dateinamen besitzt.<br /></p><br />
			<input type='button' class='button' value='Zur&uuml;ck' onClick=javascript:history.back()>";
		}
		else
		{
			//echo "parsen der konvertierten Track-Datei und speichern der Werte in der geo_tmp (table13):";
			//Initialisierung des Array-Positionszaehlers:
			$geo_arr = array();
			//$data_arr = array();
			$data_arr = array('0.00', '0.00', '0.00', '0000-00-00T00:00:00Z');
			$z = 0; //Indexzaehler des Geoarrays (0 - Anz. Datensaetz in der Log-Datei)
			
			while(!feof($fh1))
			{
				//Zeilenweise wird der Datei-Inhalt in ein Array ueberfuehrt:
				$line = strip_tags(fgets($fh1, 1024));
				
				if(stristr($line, 'Longitude:'))
				{
					if($data_arr[0] == 0.00 AND $data_arr[1] == 0.00 AND $data_arr[2] == 0.00)
					{
						$lon_value = preg_split('# #',$line);
						//print_r($lon_value)."<br />";
						$data_arr[0] = $lon_value[1];
					}
					else
					{
						$geo_arr[$z] = $data_arr;
						$z++;
						$lon_value = preg_split('# #',$line);
						//print_r($lon_value)."<br />";
						$data_arr[0] = $lon_value[1];
					}
				}
								
				if(stristr($line, 'Latitude:'))
				{
					$lat_value = preg_split('# #',$line);
					//print_r($lat_value)."<br />";
					$data_arr[1] = $lat_value[1];
				}
				
				if(stristr($line, 'Altitude:'))
				{
					$alt_value = preg_split('# #',$line);
					//print_r($alt_value)."<br />";
					$data_arr[2] = $alt_value[1];
				}
				
				if(stristr($line, 'Time:'))
				{
					$time_value = preg_split('# #',$line);
					//print_r($time_value)."<br />";
					$data_arr[3] = $time_value[1];
				}
			}
			
			//Was steht in dem Array?
			//##################################################################
			//waehrend der Testphase:
			//$result0 = mysqli_query($conn, "DELETE FROM $table13");
			//##################################################################
			/*
			$anz1 = count($data_arr);
			echo "Anz. Elemente im Daten-Array: ".$anz1."<br />";
			$anz2 = count($geo_arr);
			echo "Anz. Elemente im Geo-Array: ".$anz2."<br />";
			*/
			foreach($geo_arr AS $data_arr)
			{
				//echo $data_arr[0]." | ".$data_arr[1]." | ".$data_arr[2]." | ".$data_arr[3]."<br />";
				$altitude = number_format(($data_arr[2] * 0.3048),1,'.','');
				$date = substr($data_arr[3],0,10);
				if($date == '')
				{
					$date = '0000-00-00';
				}
				
				$time = substr($data_arr[3],11,8);
				if($time == '')
				{
					$time = '00:00:00';
				}
				$time_new = substr(gmtToLocalTime($date,$time,$timezone),11,8);	//zeitzonenkorrigierte Zeit
				$date_new = substr(gmtToLocalTime($date,$time,$timezone),0,10);	//zeitzonenkorrigiertes Datum
				//echo $altitude." / ".$date." / ".$date_new." / ".$time_new."<br />";

				$result1 = mysqli_query($conn, "INSERT INTO $table13 (longitude, latitude, altitude, date, time, user_id) VALUES ('$data_arr[0]', '$data_arr[1]', '$altitude', '$date_new', '$time_new', '$uid')");
				echo mysqli_error($conn);
			}
		}
	}
	else
	{
		echo "Es wurden keine Daten in die Datenbank &uuml;bernommen!<br /><br />
		<input type='button' class='button' value='Zur&uuml;ck' onClick=javascript:history.back()>";
	}
}

// Fkt. ermittelt die neachstgelegenen Aufnahmestandorte im Radius von 10 km in Bezug auf die folgende Objekt-ID
function getNextLocation($sr, $next_pic_id)
{
    include $sr.'/bin/share/db_connect1.php';
    $result3 = mysqli_query($conn, "SELECT * FROM $table2 WHERE pic_id = '$next_pic_id' AND aktiv = '1'");
    $row3 = mysqli_fetch_assoc($result3);
    @$long = $row3['GPSLongitude'];
    @$lat = $row3['GPSLatitude'];
    //echo "Objekt: ".$pic_id.", Long: ".$long.", Lat: ".$lat."<br />";
    //Radius: 10 km, um welchen die vorhandenen Orte ermittelt werden:
    $radius = 10000;
    $diff_lat = 0.000008999280058; //(Winkelaenderung je Meter)
    $delta_lat = $radius * $diff_lat;
    $lat_min = $lat - $delta_lat;
    $lat_max = $lat + $delta_lat;
    //echo "Breite: ".$lat.", min. Breite: ".$lat_min.", max. Breite: ".$lat_max."<br />";

    //geogr. Laenge: hier ist die Winkelaenderung / Entfernung von der geogr. Breite abhaengig:
    $delta_long = getDeltaLong($lat, $radius);
    $long_min = $long - $delta_long;
    $long_max = $long + $delta_long;
    //echo "L&auml;nge: ".$long.", min. L&auml;nge: ".$long_min.", max. L&auml;nge: ".$long_max."<br />";

    //qudratischer Auswahlbereich:
    // Ab Version 0.60.4: es wird geprueft, ob die Tabelle geo_locations existiert. Wenn ja, werden die Tabellen pictures 
    // und geo_locations zum auffinden bekannter Orte in der Naehe verwendet, wenn nicht, nur die Tabelle pictures:
    $res = mysqli_query($conn, "show tables LIKE '$table12'");
    if(mysqli_num_rows($res) == 1)
    {
        //echo "Tabelle vorhanden";
        $result5 = mysqli_query($conn, "select pic_id, City, GPSLongitude, GPSLatitude
        from 	(SELECT pic_id, City, GPSLongitude, GPSLatitude
            FROM $table2 as P2
            union all
            select locid, City, GPSLongitude, GPSLatitude from $table12) 
            as X_union
        where GPSLongitude between $long_min and $long_max
        and GPSLatitude between $lat_min and $lat_max");
    }
    else
    {
        //echo "Tabelle nicht da!!!";
        $result5 = mysqli_query($conn, "SELECT * FROM $table2 
        WHERE (GPSLongitude > $long_min 
        AND GPSLongitude < $long_max) 
        AND (GPSLatitude > $lat_min 
        AND GPSLatitude < $lat_max)");
    }
    echo mysqli_error($conn);
    $num5 = mysqli_num_rows($result5);
    //echo $num5." Orte in der Umgebung wurden gefunden.<br />";
    //von allen Treffern werden die Ortsbezeichnungen in aufsteigender Entfernung vom Aufnahmeort ermittelt:
    unset($locid);
    unset($ort_arr);
    unset($abstand);
    $locid = array();
    $ort_arr = array();
    $abstand = array();

    $it = 0;
    for($i5='0'; $i5<$num5; $i5++)
    {
        $row5 = mysqli_fetch_assoc($result5);    
        $picture_id = $row5['pic_id'];
        $city = $row5['City'];
        $longitude = $row5['GPSLongitude'];
        $latitude = $row5['GPSLatitude'];
        $delta = sqrt(pow(($long - $longitude),2) + pow(($lat - $latitude),2));

        //echo $picture_id.", ".$City.", ".$delta."<br />";
        if (!in_array($city,$ort_arr) AND ($city !== 'Ortsbezeichnung') AND ($city !== 'skipped'))
        {
            $locid[$it] = $picture_id;
            $ort_arr[$it] = $city;
            $abstand[$it] = $delta;
            $it++;
            //echo $location." wird im Array aufgenommen<br />";
        }
        elseif($city !== 'Ortsbezeichnung'AND $city !== 'skipped')
        {
            $position = array_search($city,$ort_arr);
            //echo $ort[$position].": bisheriger Abstand: ".$abstand[$position].", neuer Abstand: ".$delta."<br />";
            IF($abstand[$position] > $delta)
            {
                $locid[$position] = $picture_id;
                $abstand[$position] = $delta;
                //echo "neuer Abstand wurde uebernommen<br />";
            }
        }
    }
    $elements = count($locid);
    //echo "Es sind ".$elements." Elemente im Array.<br />Unsortierte Auflistung:<br />";
    asort($abstand);

    $iz = 0;									// $zv - Zaehlvariable
    foreach($abstand AS $ABST)
    {
        $pos = array_search($ABST,$abstand);

        if(mb_detect_encoding($ort_arr[$pos]) == 'UTF-8')
        {
                $ort_arr[$pos] = $ort_arr[$pos];
        }
        elseif(mb_detect_encoding($ort_arr[$pos]) == 'ASCII')
        {
                $ort_arr[$pos] = $ort_arr[$pos];
        }
        if($iz == 0)
        {
            return $ort_arr[$pos];
        }
    }
}

// Fkt. erzeugt das Formular zur Festlegung der Aufnahmeposition bei der Geo-Referenzierung (linke Spalte in der edit/edit_location_name.php):
// $auto_ref: gibt an, ob automat. weiter referenziert wird oder manuell

function generateGeoRefForm($sr,$uid)
{
    global $pic_id;
    include $sr.'/bin/share/global_config.php';
    include $sr.'/bin/share/db_connect1.php';
    echo "<div class='filmstripe_content_left' id='spalte1' style='overflow: hidden;'>
            <fieldset class='normal' style=' height: 95%;overflow: hidden;'>
                <legend class='normal'>Ortsbezeichnung festlegen</legend>
                <div id='scrollbox0' style='overflow-y:scroll; padding-top:0px;'>";                                        
                    $result2 = mysqli_query($conn, "SELECT CreateDate, pic_id, Owner, FileNameV, City, GPSLongitude, GPSLatitude, aktiv 
                    FROM $table2 
                    WHERE (Owner = '$uid' 
                    AND (City = 'Ortsbezeichnung' OR City = '')
                    AND GPSLongitude <> 'NULL'
                    AND GPSLatitude <> 'NULL'
                    AND aktiv = '1') 
                    ORDER BY CreateDate ASC");
                    echo mysqli_error($conn);
                    $num2 = mysqli_num_rows($result2);
                    $row2 = mysqli_fetch_assoc($result2);
                    if(!isset($_SESSION["totalNumberOfImages"]))
                    {
                        $_SESSION["totalNumberOfImages"] = $num2;
                    }
                    echo "
                    <form name = 'ortsbezeichnung' method='post' action='edit_location_name_action.php' onSubmit='return chkOrt()'>
                    <center>
                    <table class='kat'>
                    <TR>
                        <td>";

//  ~~~~~~~~~~~~~~~~    Hinweistext über Vorschaubild erzeugen:                            
                        switch($num2)
                        {
                            case '0':  
                            //wenn alle Objekte referenziert wurden, wird bei den uebersprungenen (skipped) Bildern des angemeldeten Users City wieder auf 'Ortsbezeichnung' gesetzt:
                            $result5 = mysqli_query($conn, "UPDATE $table2 SET City = 'Ortsbezeichnung' WHERE City = 'skipped' AND Owner = '$uid'");
                            // und es wird das cookie 'auto_ref' geloescht, damit eine folgende Referenzierung nicht irrtuemlich automatisch durchlaeuft:
                            // setcookie ("auto_ref", "", time() - 3600);
                            // dann gehts zurueck zur Bearbeitungs-Startseite:
                            echo "<meta http-equiv='refresh', content='0; URL=edit_start.php'>";
                            break;

                            case '1':
                            $FileNameV = $row2['FileNameV'];
                            $pic_id = $row2['pic_id'];
                            $ort = $row2['City'];
                            echo "<p class='klein'>Es gibt noch dieses Objekt ohne GPS-Ortszuweisung</p>";
                            break;

                            default:
                            $FileNameV = $row2['FileNameV'];
                            $pic_id = $row2['pic_id'];
                            $ort = $row2['City'];
                            echo "<p class='klein'>Es gibt noch ".$num2." Objekte ohne GPS-Ortszuweisung</p>";
                            break;
                        }
                        echo "</td>
                        </TR>";
// ~~~~~~~~~~~~~~~~~    Wenn noch Objekte zu referenzieren sind, wird das naechste Objekt dargestellt und es werden die umliegenden Orte ermittelt...                                               
                        //echo "File: ".$FileNameV."<br />Ort: ".$ort."<br />";
                        if ($num2 > '0')
                        {
                            $bildinfo = getimagesize($pic_thumbs_path."/".$FileNameV);
                            $breite = $bildinfo[0];
                            $hoehe = $bildinfo[1];
                            $img_string = "http://".$_SERVER['SERVER_NAME'].$inst_path."/pic2base/images/vorschau/thumbs/".$FileNameV;
                            //Datenzelle ist 300x300px gross; hier einpassen entsprechend der Ausrichtung des Vorschaubildes:
                            if($breite > $hoehe)
                            {
                                $imgsrc = "<img src='$img_string' width=\"300\" />";
                            }
                            else
                            {
                                $imgsrc = "<img src='$img_string' height=\"270\" />";
                            }
// ~~~~~~~~~~~~~~~~~~~~~    Objekt-Darstellung erledigt							
// ~~~~~~~~~~~~~~~~~~~~~    Bestimmung der Geo-Koordinaten am Aufnahmeort und Ermittlung und Sortierung der umliegenden Ortsnamen:
                            $result3 = mysqli_query($conn, "SELECT * FROM $table2 WHERE pic_id = '$pic_id' AND aktiv = '1'");
                            $row3 = mysqli_fetch_assoc($result3);
                            @$long = $row3['GPSLongitude'];
                            @$lat = $row3['GPSLatitude'];
                            //echo "Objekt: ".$pic_id.", Long: ".$long.", Lat: ".$lat."<br />";
                            //Radius: 10 km, um welchen die vorhandenen Orte ermittelt werden:
                            $radius = 10000;
                            $diff_lat = 0.000008999280058; //(Winkelaenderung je Meter)
                            $delta_lat = $radius * $diff_lat;
                            $lat_min = $lat - $delta_lat;
                            $lat_max = $lat + $delta_lat;
                            //echo "Breite: ".$lat.", min. Breite: ".$lat_min.", max. Breite: ".$lat_max."<br />";

                            //geogr. Laenge: hier ist die Winkelaenderung / Entfernung von der geogr. Breite abhaengig:
                            $delta_long = getDeltaLong($lat, $radius);
                            $long_min = $long - $delta_long;
                            $long_max = $long + $delta_long;
                            //echo "L&auml;nge: ".$long.", min. L&auml;nge: ".$long_min.", max. L&auml;nge: ".$long_max."<br />";

                            //qudratischer Auswahlbereich:
                            // Es wird geprueft, ob die Tabelle geo_locations existiert. Wenn ja, werden die Tabellen pictures 
                            // und geo_locations zum auffinden bekannter Orte in der Naehe verwendet, wenn nicht, nur die Tabelle pictures:
                            $res = mysqli_query($conn, "SHOW TABLES LIKE '$table12'");
                            if (mysqli_num_rows($res) == 1)
                            {
                                $result5 = mysqli_query($conn, "SELECT pic_id, City, GPSLongitude, GPSLatitude
                                FROM 	(SELECT pic_id, City, GPSLongitude, GPSLatitude
                                        FROM $table2 as P2
                                        union all
                                        SELECT locid, City, GPSLongitude, GPSLatitude FROM $table12) 
                                        as X_union
                                WHERE GPSLongitude between $long_min and $long_max
                                and GPSLatitude between $lat_min and $lat_max");
                                //echo "Fehler bei Abfrage Tabelle 2 und 12: ".mysqli_error($conn);
                            }
                            else
                            {
                                $result5 = mysqli_query($conn, "SELECT * FROM $table2 
                                WHERE (GPSLongitude > $long_min 
                                AND GPSLongitude < $long_max) 
                                AND (GPSLatitude > $lat_min 
                                AND GPSLatitude < $lat_max)");
                                //echo "Fehler bei Abfrage Tabelle 2: ".mysqli_error($conn);
                            }

                            echo mysqli_error($conn);
                            $num5 = mysqli_num_rows($result5); 
                            //echo "Weitere Orte im Umkreis: ".$num5."<br />";
                            //von allen Treffern werden die Ortsbezeichnungen in aufsteigender Entfernung vom Aufnahmeort ermittelt:
                            unset($locid);
                            unset($ort_arr);
                            unset($abstand);
                            $locid = array();
                            $ort_arr = array();
                            $abstand = array();

                            $it = 0;
                            for ($i5='0'; $i5<$num5; $i5++)
                            {
                                $row5 = mysqli_fetch_assoc($result5);
                                $picture_id = $row5['pic_id'];
                                $city = $row5['City'];
                                $longitude = $row5['GPSLongitude'];
                                $latitude = $row5['GPSLatitude'];
                                $delta = sqrt(pow(($long - $longitude),2) + pow(($lat - $latitude),2));

                                //echo $picture_id.", ".$city.", ".$delta."<br />";
                                if (!in_array($city,$ort_arr) AND ($city !== 'Ortsbezeichnung') AND ($city !== 'skipped'))
                                {
                                    $locid[$it] = $picture_id;
                                    $ort_arr[$it] = $city;
                                    $abstand[$it] = $delta;
                                    $it++;
                                }
                                elseif ($city !== 'Ortsbezeichnung'AND $city !== 'skipped')
                                {
                                    $position = array_search($city,$ort_arr);
                                    //echo $ort[$position].": bisheriger Abstand: ".$abstand[$position].", neuer Abstand: ".$delta."<br />";
                                    if($abstand[$position] > $delta)
                                    {
                                        $locid[$position] = $picture_id;
                                        $abstand[$position] = $delta;
                                    }
                                }
                            }
                            $elements = count($locid);
                            asort($abstand);

// ~~~~~~~~~~~~~~~~~~~~~~~  Ermittlung und Sortierung der umliegenden Orte abgeschlossen 

// ~~~~~~~~~~~~~~~~~~~~~~~  Erzeugung der weiteren Bedienelemente:
                            echo "
                            <TR>
                                <td style='height:280px;'>",$imgsrc."
                                </td>
                            </TR>";				

                            if ($elements == '0')
                            {
                                //wenn weit und breit kein bekannter Ort vorhanden ist, wird nur das Textfeld angezeigt:
                                echo '<INPUT TYPE = "hidden" name="ort" id="ort" class="Auswahl" maxlength="50" style = "width:200px;" />';
                            }
                            else
                            {
                                echo '
                                <TR>
                                <td><p class="klein">Aufnahmestandort dieses Bildes:</p>
                                <select name="ort" id="ort" size="1" class="Auswahl" style = "margin:10px; width:303px; font-size:10pt;">
                                <option value = "0">neuen Ort anlegen</option>';
                                $zv = 0;			// $zv - Zaehlvariable
                                foreach ($abstand AS $ABST)
                                {
                                    if ($zv == 0)
                                    {
                                        $auswahl = 'SELECTED';
                                    }
                                    else
                                    {
                                        $auswahl = '';
                                    }
                                    $pos = array_search($ABST,$abstand);

                                    if(mb_detect_encoding($ort_arr[$pos]) == 'UTF-8')
                                    {
                                        $ort_arr[$pos] = $ort_arr[$pos];
                                    }
                                    elseif(mb_detect_encoding($ort_arr[$pos]) == 'ASCII')
                                    {
                                        $ort_arr[$pos] = $ort_arr[$pos];
                                    }

                                    echo "<option value='$ort_arr[$pos]' $auswahl>".$ort_arr[$pos]."</option>";
                                    //echo $locid[$pos]."&#160;&#160;&#160;&#160;".$ort_arr[$pos]."&#160;&#160;&#160;&#160;".$ABST."<br />";
                                    //echo $ABST.", zugeh. Ort: ".$ort[$pos]."<br />";
                                    $zv++;
                                }
                                echo '	
                                </select>
                                
                                </td>
                            </tr>

                            <tr>
                                <td class="kat">
                                    <span class="klein" id="auto_ref_txt">Weitere Objekte autom. mit diesem Ort referenzieren:</span>
                                    <input type="checkbox" id="auto_ref" name="auto_ref" style="vertical-align:middle;">
                                </td>
                            </TR>

                            <TR>
                                <td class="kat" id="p1" style="padding-top:5px;">
                                    <p align="center">
                                        <input id="button1" type="button" class="button" style="width:300px;" value="Weiter mit dem gew&auml;hlten Ort" onClick="callRefScript()" />
                                    </p>
                                </td>
                            </TR>';
                            }
                    
                            echo "
                            <TR>
                                <td class='kat' id='p2'>
                                    <p>
                                        <input type='text' id='neuerOrt' name='neuerOrt' maxlength='50' class='Auswahl' style = 'margin-bottom:5px; width:295px; font-size:10pt;' placeholder = 'Hier neuen Ort eintragen' />
                                        <input type='button' id='button2' class='button' style='width:300px;' value='Weiter mit diesem Ort' onClick='callRefScript()' />
                                    </p>
                                </td>
                            </TR>

                            <TR>
                                <td class = 'kat' style='border-color:var(--color1); border-style:solid; border-width:1px; padding-top:5px;'>
                                    <INPUT type='button' class='button' style='margin-right:0px;' title='Die Referenzierung dieses einen Bildes &uuml;berspringen...' value='Objekt &uuml;berspringen' onClick='location.href=\"skip_georef.php?pic_id=$pic_id&uid=$uid\"' />
                                    <INPUT type='button' class='button' title='Die gesamte Referenzierung abbrechen...' value='Referenzierung abbrechen' onClick='location.href=\"cancel_georef.php?uid=$uid\"' />
                                </td>
                            </TR>";
                        }
                        else
                        {
                            $pic_id = '';
                        }
                   
                    echo "
                    </table>
                    </center>
                    <input type='hidden' name='pic_id' value='$pic_id'>
                    </FORM>
                </div>
                
                <center>
                    <div id='geoRefProgressBar' style='display:none;'>
                        <div id='headline'>
                        </div>
                        
                        <div id='geoRefProgressBar1' style='display:none;'>
                            <img src='../../share/images/green.gif' id='img_bar' />
                        </div>
                        
                        <div id='remainingPics'>
                        </div>
                    </div>
                </center>
 
        </fieldset>
    </div>";
return $pic_id;
}

// Fkt. ermittelt den zu den Geo-Koordinaten des Bildes mit der pic_id am naechsten gelegene Ort; wenn dieser mit dem vorigen uebereinstimmt
// wird true ausgegeben, anderenfalls false:

function getNearestLocation($sr,$pic_id,$next_location)
{
    // ~~    Bestimmung der Geo-Koordinaten am Aufnahmeort und Ermittlung und Sortierung der umliegenden Ortsnamen:
    include $sr.'/bin/share/global_config.php';
    include $sr.'/bin/share/db_connect1.php';
    
    $result1 = mysqli_query($conn, "SELECT * FROM $table2 WHERE pic_id = '$pic_id' AND aktiv = '1'");
    $row1 = mysqli_fetch_assoc($result1);
    @$long = $row1['GPSLongitude'];
    @$lat = $row1['GPSLatitude'];
    //echo "Objekt: ".$pic_id.", Long: ".$long.", Lat: ".$lat."<br />";
    //Radius: 10 km, um welchen die vorhandenen Orte ermittelt werden:
    $radius = 10000;
    $diff_lat = 0.000008999280058; //(Winkelaenderung je Meter)
    $delta_lat = $radius * $diff_lat;
    $lat_min = $lat - $delta_lat;
    $lat_max = $lat + $delta_lat;
    //echo "Breite: ".$lat.", min. Breite: ".$lat_min.", max. Breite: ".$lat_max."<br />";

    //geogr. Laenge: hier ist die Winkelaenderung / Entfernung von der geogr. Breite abhaengig:
    $delta_long = getDeltaLong($lat, $radius);
    $long_min = $long - $delta_long;
    $long_max = $long + $delta_long;
    //echo "L&auml;nge: ".$long.", min. L&auml;nge: ".$long_min.", max. L&auml;nge: ".$long_max."<br />";

    //qudratischer Auswahlbereich:
    // Ab Version 0.60.4: es wird geprueft, ob die Tabelle geo_locations existiert. Wenn ja, werden die Tabellen pictures 
    // und geo_locations zum auffinden bekannter Orte in der Naehe verwendet, wenn nicht, nur die Tabelle pictures:
    $res = mysqli_query($conn, "show tables LIKE '$table12'");
    IF(mysqli_num_rows($res) == 1)
    {
            //echo "Tabelle vorhanden";
            $result2 = mysqli_query($conn, "select pic_id, City, GPSLongitude, GPSLatitude
                from (SELECT pic_id, City, GPSLongitude, GPSLatitude
                FROM $table2 as P2
                union all
                select locid, City, GPSLongitude, GPSLatitude from $table12) 
                as X_union
            where GPSLongitude between $long_min and $long_max
            and GPSLatitude between $lat_min and $lat_max");
    }
    ELSE
    {
            //echo "Tabelle nicht da!!!";
            $result2 = mysqli_query($conn, "SELECT * FROM $table2 
            WHERE (GPSLongitude > $long_min 
            AND GPSLongitude < $long_max) 
            AND (GPSLatitude > $lat_min 
            AND GPSLatitude < $lat_max)");
    }

    echo mysqli_error($conn);
    $num2 = mysqli_num_rows($result2);
    //echo $num5." Orte in der Umgebung wurden gefunden.<br />";
    //von allen Treffern werden die Ortsbezeichnungen in aufsteigender Entfernung vom Aufnahmeort ermittelt:
    unset($locid);
    unset($ort_arr);
    unset($abstand);
    $locid = array();
    $ort_arr = array();
    $abstand = array();

    $it = 0;
    FOR($i2='0'; $i2<$num2; $i2++)
    {
        $row2 = mysqli_fetch_assoc($result2);    
        $picture_id = $row2['pic_id'];
        $city = $row2['City'];
        $longitude = $row2['GPSLongitude'];
        $latitude = $row2['GPSLatitude'];
        $delta = sqrt(pow(($long - $longitude),2) + pow(($lat - $latitude),2));

        IF (!in_array($city,$ort_arr) AND ($city !== 'Ortsbezeichnung') AND ($city !== 'skipped'))
        {
            $locid[$it] = $picture_id;
            $ort_arr[$it] = $city;
            $abstand[$it] = $delta;
            $it++;
        }
        ELSEIF($city !== 'Ortsbezeichnung'AND $city !== 'skipped')
        {
            $position = array_search($city,$ort_arr);
            //echo $ort[$position].": bisheriger Abstand: ".$abstand[$position].", neuer Abstand: ".$delta."<br />";
            IF($abstand[$position] > $delta)
            {
                $locid[$position] = $picture_id;
                $abstand[$position] = $delta;
                //echo "neuer Abstand wurde uebernommen<br />";
            }
        }
    }
    $elements = count($locid);
    //echo "Es sind ".$elements." Elemente im Array.<br />sortierte Auflistung:<br />";
    asort($abstand);
    // ~  Ermittlung und Sortierung der umliegenden Orte abgeschlossen 
    
    $keys = array_keys($abstand);
    
    if($ort_arr[$keys[0]] === $next_location)
    {
        return true;
    }
    else
    {
        return false;
    }
}

// Fkt liefert die Anzahl noch zu geo-referenzierender Objekte des Users mit der $uid zurueck
function getNumberOfRefPictures($sr,$uid)
{
    include $sr.'/bin/share/global_config.php';
    include $sr.'/bin/share/db_connect1.php';
    $result1 = mysqli_query($conn, "SELECT CreateDate, pic_id, Owner, FileNameV, City, GPSLongitude, GPSLatitude, aktiv 
            FROM $table2 
            WHERE (Owner = '$uid' 
            AND (City = 'Ortsbezeichnung' OR City = '')
            AND GPSLongitude <> 'NULL'
            AND GPSLatitude <> 'NULL'
            AND aktiv = '1') 
            ORDER BY CreateDate ASC");
//          echo mysqli_error($conn);
    $num1 = mysqli_num_rows($result1);
    return $num1;
}