<?php

//###################################################################################################
//
//Ermittlung der Anzahl fehlender Dateien im Rahmen der DB-Wartung (Originale, Vorschau, Hist, Mono):
//
//###################################################################################################

include 'global_config.php';
include $sr.'/bin/share/db_connect1.php';

//memory_limit dynamisch anpassen, falls der berechnete Wert groesser als der vorhandene Wert ist.
$result1 = mysqli_query($conn, "SELECT COUNT(*) FROM $table2");
$row1 = mysqli_fetch_row($result1);
$pic_records = $row1[0];
//bei 50000 Datensaetzen waren 250M erforderlich, daher wird hier vorsorglich (großzügig) dynamisch angepasst:
$steps = ceil($pic_records / 50000);
//echo "<font color='white'>".$steps." - </font>";
$memory_avail = ini_get('memory_limit');
$memory_value = $steps * 500;

if ($memory_value > $memory_avail)
{
    $memory = $memory_value . "M";
    ini_set('memory_limit', $memory);
    //echo "<p style='margin-top:20px;'><font color='green'>Die Speichergrenze wird vor&uuml;bergehend von " . $memory_avail . " auf " . ini_get('memory_limit') . " angehoben.</font></p>";
}

ini_set('max_execution_time', '60');

//temporaer genutzte Tabelle wird geleert:
$result21 = mysqli_query($conn, "TRUNCATE `ICE_V_pic_kat_dubls`");
echo mysqli_error($conn);
//#########################	
//es wird fuer alle Eintraege in der tabelle pictures geprueft, ob die Vorschaubilder
//FileName, FileNameHQ, FileNameV, FileNameHist, FileNameHist_r, FileNameHist_g, FileNameHost_b und FileNameMono vorhanden sind. 
//Wenn nicht, werden die fehlenden Objekte ermittelt

//In der Tabelle pictures werden Felder, in denen eigentlich ein Dateiname stehen muesste, mit dem vorgesehenen Eintrag belegt, 
//damit es weiter unten zu einer Differenbildung kommen kann:
$result22 = mysqli_query($conn, "UPDATE $table2 SET FileName = CONCAT(pic_id,'.jpg') WHERE FileName = ''");
$result23 = mysqli_query($conn, "UPDATE $table2 SET FileNameHQ = CONCAT(pic_id,'_hq.jpg') WHERE FileNameHQ = ''");
$result24 = mysqli_query($conn, "UPDATE $table2 SET FileNameV = CONCAT(pic_id,'_v.jpg') WHERE FileNameV = ''");
$result25 = mysqli_query($conn, "UPDATE $table2 SET FileNameHist = CONCAT(pic_id,'_hist.gif') WHERE FileNameHist = ''");
$result26 = mysqli_query($conn, "UPDATE $table2 SET FileNameHist_r = CONCAT(pic_id,'_hist_r.gif') WHERE FileNameHist_r = ''");
$result27 = mysqli_query($conn, "UPDATE $table2 SET FileNameHist_g = CONCAT(pic_id,'_hist_g.gif') WHERE FileNameHist_g = ''");
$result28 = mysqli_query($conn, "UPDATE $table2 SET FileNameHist_b = CONCAT(pic_id,'_hist_b.gif') WHERE FileNameHist_b = ''");
$result29 = mysqli_query($conn, "UPDATE $table2 SET FileNameMono = CONCAT(pic_id,'_mono.jpg') WHERE FileNameMono = ''");
//echo mysqli_error($conn);
$result30 = mysqli_query($conn, "SELECT FileName, FileNameHQ, FileNameV, FileNameHist, FileNameHist_r, FileNameHist_g, FileNameHist_b, FileNameMono FROM $table2");
//echo mysqli_error($conn);

$ori_files_soll = array();
$hq_files_soll = array();
$v_files_soll = array();
$hist_files_soll = array();
$hist_r_files_soll = array();
$hist_g_files_soll = array();
$hist_b_files_soll = array();
$mono_files_soll = array();

while($row = mysqli_fetch_array($result30))
{
    foreach($row AS $key => $value)
    {
      //echo "Element: ".$row[0].", Key: ".$key." - Wert: ".$value."<br />";
        switch(trim($key))
        {
            case 'FileName':
                $ori_files_soll[$row[0]] = $value;	
            break;

            case 'FileNameHQ':
                $hq_files_soll[$row[0]] = $value;	
            break;

            case 'FileNameV':
                $v_files_soll[$row[0]] = $value;
            break;

            case 'FileNameHist':
                $hist_files_soll[$row[0]] = $value;
            break;

            case 'FileNameHist_r':
                $hist_r_files_soll[$row[0]] = $value;
            break;

            case 'FileNameHist_g':
                $hist_g_files_soll[$row[0]] = $value;
            break;

            case 'FileNameHist_b':
                $hist_b_files_soll[$row[0]] = $value;
            break;

            case 'FileNameMono':
                $mono_files_soll[$row[0]] = $value;
            break;
        }
    }
}

ksort($ori_files_soll);
ksort($hq_files_soll);
ksort($v_files_soll);
ksort($hist_files_soll);	//print_r($hist_files_soll);
ksort($hist_r_files_soll);
ksort($hist_g_files_soll);
ksort($hist_b_files_soll);	
ksort($mono_files_soll);	//print_r($mono_files_soll);

$erledigt = 0;	//Anzahl der erledigten Datei-Wiederherstellungen
$n_hq = 0;
$n_v = 0;
$mf = 0;
//echo $kml_dir;
//Ermittlung der Dateien, die in den Objekt-Ordnern liegen:
$e[] = exec("ls ".$pic_path."/", $ori_files_ist);
$a[] = exec("ls ".$pic_hq_path."/", $hq_files_ist);	//print_r($retval2);
$b[] = exec("ls ".$pic_thumbs_path."/", $v_files_ist);
$c[] = exec("ls ".$hist_path."/", $hist_files_ist);
$d[] = exec("ls ".$monochrome_path."/", $mono_files_ist);

//#####################################	
ksort($ori_files_ist);
ksort($hq_files_ist);		
ksort($v_files_ist);
sort($hist_files_ist);	//print_r($hist_files_ist);
//Das Hist-Array des Ist-Bestandes ist aus Performance-Gruenden in die 4 Bestandteile (grau / rot / gruen / blau) zu zerlegen,
//ansonsten gibt es bei der folgenden Differenzbildung erhebliche Verzoegerungen:

$hist_r_files_ist = array();
$hist_g_files_ist = array();
$hist_b_files_ist = array();
foreach($hist_files_ist AS $key => $value)
{
	//echo $key." - ".$value."<br />";
	if(stristr($value, 'hist_0.gif'))
	{
		$hist_r_files_ist[] = $value;
		unset($hist_files_ist[$key]);
	}
	elseif(stristr($value, 'hist_1.gif'))
	{
		$hist_g_files_ist[] = $value;
		unset($hist_files_ist[$key]);
	}
	elseif(stristr($value, 'hist_2.gif'))
	{
		$hist_b_files_ist[] = $value;
		unset($hist_files_ist[$key]);
	}
}
ksort($hist_files_ist);
ksort($hist_r_files_ist);
ksort($hist_g_files_ist);
ksort($hist_b_files_ist);

ksort($mono_files_ist);	
//####################################

//Ermittlung der Differenzen zwischen Soll und Ist:
	
$ori_files_diff = array_diff($ori_files_soll, $ori_files_ist);
$hq_files_diff = array_diff($hq_files_soll, $hq_files_ist);
$v_files_diff = array_diff($v_files_soll, $v_files_ist);
$hist_files_diff = array_diff($hist_files_soll, $hist_files_ist);
$hist_r_files_diff = array_diff($hist_r_files_soll, $hist_r_files_ist);
$hist_g_files_diff = array_diff($hist_g_files_soll, $hist_g_files_ist);
$hist_b_files_diff = array_diff($hist_b_files_soll, $hist_b_files_ist);
$mono_files_diff = array_diff($mono_files_soll, $mono_files_ist);

//###################################
	
//nicht mehr bnoetigte Arrays werden geleert:	
unset($hist_files_ist);
unset($hist_r_files_ist);
unset($hist_g_files_ist);
unset($hist_b_files_ist);
unset($hq_files_ist);
unset($v_files_ist);
unset($ori_files_ist);

unset($hist_files_soll);
unset($hist_r_files_soll);
unset($hist_g_files_soll);
unset($hist_b_files_soll);
unset($hq_files_soll);
unset($v_files_soll);
unset($ori_files_soll);

//fehlende Histogramme und monochr. Dateien werden im Array $hist_mono_files_diff zusammengefasst:
$hist_mono_files_diff = array();
foreach($hist_files_diff AS $key => $value)
{
    $hist_mono_files_diff[] = $key;	
}
foreach($hist_r_files_diff AS $key => $value)
{
    $hist_mono_files_diff[] = $key;		
}
foreach($hist_g_files_diff AS $key => $value)
{
    $hist_mono_files_diff[] = $key;		
}
foreach($hist_b_files_diff AS $key => $value)
{
    $hist_mono_files_diff[] = $key;		
}
foreach($mono_files_diff AS $key => $value)
{
    $hist_mono_files_diff[] = $key;		
}

//fuer den Fortschrittsbalken wird die Anzahl der neu zu erstellenden Dateien ermittelt:
$i_neu = count($ori_files_diff) + count($hq_files_diff) + count($v_files_diff) + count($hist_files_diff) + count($hist_r_files_diff) + count($hist_g_files_diff) + count($hist_b_files_diff) + count($mono_files_diff);

//es werden nur die pic_id's benoetigt, die Dateinamen werden aus den Arrays entfernt:
$ori_files = array();
$hq_files = array();
$v_files = array();
$hist_mono_files = array();
foreach($ori_files_diff AS $key => $value)
{
    $ori_files[] = $key;
}

foreach($hq_files_diff AS $key => $value)
{
    $hq_files[] = $key;
}

foreach($v_files_diff AS $key => $value)
{
    $v_files[] = $key;
}

$obj = new stdClass();
$obj->anzahl = $i_neu;					                //Anzahl der neu zu erstellenden Dateien
$obj->ori_files_array = $ori_files;			            //Array der fehlenden Original-Objekte
$obj->hq_files_array = $hq_files;			            //Array der fehlenden HQ-Objekte
$obj->v_files_array = $v_files;				            //Array der fehlenden Thumbs
$obj->hist_mono_files_array = $hist_mono_files_diff;     //Array der fehlenden mono- und Hist-Dateien
$output = json_encode($obj);
echo $output;
?>