// existieren gespeicherte Werte? - sonst nimm Vorgaben:

	if(sessionStorage.getItem("lon") !== 'undefined' && sessionStorage.getItem("lon") !== null)
	{
		var lon = roundNumber(sessionStorage.getItem("lon"),7);
	}
	else
	{
		var lon = 10.9528111;
	}
	document.getElementById('lon').value = lon;
	
	if(sessionStorage.getItem("lat") !== 'undefined' && sessionStorage.getItem("lat") !== null)
	{
		var lat = roundNumber(sessionStorage.getItem("lat"),7);
	}
	else
	{
		var lat = 51.7912321;
	}
	document.getElementById('lat').value = lat;
	
	var center = lat + ',' + lon;
	document.getElementById('location').value = center;
	
	if(sessionStorage.getItem("radius") !== 'undefined' && sessionStorage.getItem("radius") !== null && sessionStorage.getItem("radius") !== 0)
	{
		var radius = sessionStorage.getItem("radius");
		document.getElementById('radius').value = radius;
	}
	else
	{
		var radius = 1;
	}
	
	if(sessionStorage.getItem("zoom") !== 'undefined' && sessionStorage.getItem("zoom") !== null && sessionStorage.getItem("zoom") !== 0)
	{
		var zoom = sessionStorage.getItem("zoom");
	}
	else
	{
		var zoom = 12;
	}
	
	if(sessionStorage.getItem("geojsonFile") !== 'undefined' && sessionStorage.getItem("geojsonFile") !== null)
	{
		var geojsonFile = sessionStorage.getItem("geojsonFile");
	}
	else
	{
		var geojsonFile = "0";
	}
	//alert(geojsonFile);	
	
	function roundNumber(number, decimals) 
	{
	    var newnumber = new Number(number+'').toFixed(parseInt(decimals));
	    return parseFloat(newnumber); 
	}
	
// Behandlung der Slider-Events:
	
	var slider = document.getElementById("radius");
    var output = document.getElementById("radiusval");
    output.innerHTML = slider.value; // zeigt aktuellen Slider-Wert an
    
    // Update des aktuellen Slider-Wertes bei jeder Änderung
    slider.oninput = function() {
      output.innerHTML = this.value;
    } 

// Behandlung der Karten-Events:

	//Farb-Einstellungen:
	var pointFillColor = 'RGB(0,100,255,1)';
	var circleFillColor = 'RGB(100,100,100,0.2)';
	var circleBorderColor = 'RGB(0,100,255,1)';
	
	const attributionControl = new ol.control.Attribution({
		  collapsible: true
		});

	// ########################################################################
	
    var featureCollection = new ol.Collection();

    // ###   Erzeugung des Features 'Punkt' an der Stelle lon, lat #############
    var feature = new ol.Feature({
        geometry: new ol.geom.Point(ol.proj.fromLonLat([lon, lat]))
    });
    featureCollection.push(feature);
    
	// #########################################################################
    
    // #############  Style fuer Treffer-Punkte ################################
    const recordPoint = new ol.style.Circle({
    	fill: new ol.style.Fill({
    		color: [255,0,0,1],
    	}),
    	stroke: new ol.style.Stroke({
    		color: [255,0,0,1],
    		width: 1,
    	}),
    	radius: 5
    });
    const activeRecordPoint = new ol.style.Circle({
    	fill: new ol.style.Fill({
    		color: [255,255,0,1],
    	}),
    	stroke: new ol.style.Stroke({
    		color: [255,0,0,1],
    		width: 1,
    	}),
    	radius: 10
    });
    // #########################################################################
    
	// #############  Erzeugung der Karte:  #####################################
    const map = new ol.Map({
        target: 'map',
        view: new ol.View({
            center: ol.proj.fromLonLat([lon, lat]),
            zoom: zoom,
        }),
    controls: ol.control.defaults({attribution: false}).extend([attributionControl])
    });
    //alert("Map-Center: " + center);
	// ##########################################################################
	
    // ###########   MapLayers:  ################################################
    // OSM-Karte:
    var raster = new ol.layer.Tile({
        source: new ol.source.OSM(),
        visible: true,
        title: 'OSMStandard'
    });
    
    // aktueller Standort:
    var vector = new ol.layer.Vector({
        source: new ol.source.Vector({
            features: featureCollection
        }),
        visible: true,
        style: new ol.style.Style({
            image: new ol.style.Circle({
                radius: 5,
                fill: new ol.style.Fill({
                    color: '#0055ff'
                })
            })
        }),
        title: 'actualPosition'
    });

    var circleFeature = new ol.Feature({
        geometry: new ol.geom.Polygon(getCircleCoords([lon, lat], radius))
    });
    
	// zu betrachtender Umkreis:
    var kreis = new ol.layer.Vector({
        source: new ol.source.Vector({
            features: [circleFeature]
        	}),
        visible: true,
        style: new ol.style.Style({
            stroke: new ol.style.Stroke({
                color: 'RGB(80,80,80)',
                width: 1
            }),
            fill: new ol.style.Fill({
                color: [160, 160, 160, .4]
            })
        }),
        title: 'circle'
    });
    
    // Ebene der Ergebnismenge:
    if (geojsonFile !== '1')
	{
    	var foundObjects = new ol.layer.Vector({
        	source: new ol.source.Vector({
        		url: encodeURI(geojsonFile),
        		format: new ol.format.GeoJSON()
        	}),
        	visible: true,
        	style: new ol.style.Style({
                image: recordPoint
        	}),
        	title: 'foundObjects'
        });
	}
    else
	{
    	alert("kein GeoJSON-File");
	}
      
	// ########   Zusammenfassen der Layer zu einer LayerGroup ############
    const baseLayerGroup = new ol.layer.Group({
		layers: [
			raster, kreis, vector, foundObjects
			]
    });
    map.addLayer(baseLayerGroup);
    
	// #####################################################################
    
    // Vector Feature Popup Information
    
    const overlayContainerElement = document.querySelector('.overlay-container');
    const overlayLayer = new ol.Overlay({
    	element: overlayContainerElement,
    	offset: [0,-10]
    })
    map.addOverlay(overlayLayer);
    
    const overlayFeaturePicid = document.getElementById('feature-pic_id');
    const overlayFeatureObjuri = document.getElementById('feature-obj_uri');
    const overlayFeatureAddObj = document.getElementById('feature-add-obj');	// Hinweis auf weitere Objekte
    // Vector Feature Popup Logic
    
    //map.on('pointermove', function(e){
    	map.on('click', function(e){
    	overlayLayer.setPosition(undefined);
    	var i = 0;
    	let hint = "";
    	//console.log(e);
    	map.forEachFeatureAtPixel(e.pixel, function(feature, layer){
    		let clickedCoordinate = e.coordinate;
    		//console.log(e.coordinate);
    		//console.log(feature.get('pic_id'));
    		if(feature.get('pic_id') != undefined)
    		{
    			i++;
    			if(i === 1)
				{
					// wenn nur ein Objekt an dem Standort aufgenommen wurde, wird dessen Vorschaubild und die Objekt-ID angezeigt:
    				let clickedFeaturePicid = feature.get('pic_id');
	    			let clickedFeatureObjuri = feature.get('obj_uri');
		    		overlayLayer.setPosition(clickedCoordinate);
		    		overlayFeaturePicid.innerHTML = "Objekt-ID: " + clickedFeaturePicid + "<br />";
		    		overlayFeatureObjuri.innerHTML = "<img src=" + clickedFeatureObjuri + " />";
		    		overlayFeatureAddObj.innerHTML = " ";
				}
    			else if(i > 1)
    			{
    				// wenn nur mehrere Objekte an dem Standort aufgenommen wurden, wird bei dem ersten dessen Vorschaubild, die Objekt-ID
    				// und der Hinweis auf weitere Objekte angezeigt. Die Objekt-IDs sind anklickbar:
    				if(i===2)
					{
    					overlayFeatureAddObj.innerHTML = "Weitere Objekte:";
					}
    				let clickedFeaturePicid = " " + feature.get('pic_id');
    				let url = feature.get('obj_uri');
	    			overlayLayer.setPosition(clickedCoordinate);
	    			overlayFeatureAddObj.innerHTML += "<div id='tooltip5'><span style='cursor: pointer;'><a>" + clickedFeaturePicid + "<span><img src=" + url + "></a></span></span></div>";
    			}
    		}
    	})
    })
    // #####################################################################
	
	// ##############   Änderung des Standortes:   ######################### 
    var modify = new ol.interaction.Modify({
        features: featureCollection
    });

    modify.on('modifyend',function(e){
    	getFeatureCoord();
    	var lon = document.getElementById("lon").value;
        sessionStorage.setItem("lon", lon);
        var lat = document.getElementById("lat").value;
        sessionStorage.setItem("lat", lat);
    });

    map.addInteraction(modify);
    // ######################################################################
    
    map.on('moveend', (event) => {
        //console.log(event);
        sessionStorage.setItem("zoom", map.getView().getZoom());
    });
    
    // #############Steuerelemente (Controls)   #############################
    // #############   hinzufügen der Überblicks-Karte:   ###################
    const overviewMapControl = new ol.control.OverviewMap({
		tipLabel: 'Kartenausschnitt',
		layers: [
			new ol.layer.Tile({
				source: new ol.source.OSM()
			})
		]
    });
    map.addControl(overviewMapControl);
    // ######################################################################
    
    // #############   hinzufügen des Maßstabs   ############################
    const scaleLineControl = new ol.control.ScaleLine({
		minWidth: 200,
		units: 'metric',
		bar: true,
		steps: 4,
		text: true
    });
    map.addControl(scaleLineControl);
    // ######################################################################
    
    function getFeatureCoord()
    {
    	coord = ol.proj.transform(feature.getGeometry().getCoordinates(), 'EPSG:3857', 'EPSG:4326');
    	// alert("Koordinaten: " + coord);
    	// Nachkommastellen (dec):
    	dec = 7;
    	lon = parseFloat(coord[0].toFixed(dec));
    	lat = parseFloat(coord[1].toFixed(dec));
    	document.getElementById("lat").value = lat;
    	document.getElementById("lon").value = lon;
    	document.getElementById("location").value = lat + "," + lon;
    	updateCircle([lon, lat], document.getElementById('radius').value);
    }

    // radius-editor
    document.getElementById('radius').addEventListener('change', function(){
        let newRadius = this.value * Math.pow(2, map.getView().getZoom()) * 0.0105;
        updateCircle([lon, lat], this.value);
        sessionStorage.setItem("radius", this.value);
    });
    
    function getCircleCoords(center, radius)
    {
    	var coords = [[]];
        var segmentsCount = 60;
        var center5243 = ol.proj.transform(center, "EPSG:4326", 'EPSG:5243');
        var radiusMeter = radius * 1000.0;

        for (var i = 0; i < segmentsCount + 1; ++i)
        {
        	var coord5243 = [center5243[0] + Math.sin(i * Math.PI * 2 / segmentsCount) * radiusMeter, center5243[1] + Math.cos(i * Math.PI * 2 / segmentsCount) * radiusMeter];
        	coords[0].push(ol.proj.transform(ol.proj.transform(coord5243, 'EPSG:5243', 'EPSG:4326'), "EPSG:4326", "EPSG:3857"));
        }
        return coords;
    }

    function updateCircle(center, radius)
    {
    	circleFeature.getGeometry().setCoordinates(getCircleCoords(center, radius));
    }
    // ###################################################################################

    if(sessionStorage.getItem("zoom") !== 'undefined' && sessionStorage.getItem("zoom") !== null && sessionStorage.getItem("zoom") !== 0)
	{
		var zoom = sessionStorage.getItem("zoom");
		map.getView().setZoom(zoom);
	}
	else
	{
		var zoom = 12;
	}
	
	//alert("Parameter bei Skript-Aufruf: Center: " + center + ", Radius: " + radius + ", Zoom: " + zoom);